

local LootLink = LootLink;




LootLink.SearchParameters = {};



do
	local setWidth = UIDropDownMenu_SetWidth;
	
	setWidth(90, LootLink_SearchFrame_RarityDD);
	setWidth(90, LootLink_SearchFrame_BindTypeDD);
	setWidth(140, LootLink_SearchFrame_EquipLocationDD);
	setWidth(228, LootLink_SearchFrame_TypeAndSubtypeDD);
end



LootLink_SearchFrame_RarityDDText:SetJustifyH("CENTER");
LootLink_SearchFrame_BindTypeDDText:SetJustifyH("CENTER");
LootLink_SearchFrame_EquipLocationDDText:SetJustifyH("CENTER");
LootLink_SearchFrame_TypeAndSubtypeDDText:SetJustifyH("CENTER");



LootLink_SearchFrame_RarityDDLabel:ClearAllPoints();
LootLink_SearchFrame_RarityDDLabel:SetPoint("RIGHT", "LootLink_SearchFrame_RarityDD", "LEFT", 10, 4);

LootLink_SearchFrame_BindTypeDDLabel:ClearAllPoints();
LootLink_SearchFrame_BindTypeDDLabel:SetPoint("RIGHT", "LootLink_SearchFrame_BindTypeDD", "LEFT", 10, 4);

LootLink_SearchFrame_EquipLocationDDLabel:ClearAllPoints();
LootLink_SearchFrame_EquipLocationDDLabel:SetPoint("RIGHT", "LootLink_SearchFrame_EquipLocationDD", "LEFT", 10, 4);

LootLink_SearchFrame_TypeAndSubtypeDDLabel:ClearAllPoints();
LootLink_SearchFrame_TypeAndSubtypeDDLabel:SetPoint("RIGHT", "LootLink_SearchFrame_TypeAndSubtypeDD", "LEFT", 10, 4);




function LootLink:Search_Toggle()
	local frame = self.SEARCH_FRAME;
	
	if (frame:IsShown()) then
		frame:Hide();
	else
		frame:Show();
	end
end




function LootLink:Search_LoadValues()
	local params = self.SearchParameters;
	
	
	if (self.Config.LightMode) then
		params.text = nil;
		LootLink_SearchFrame_AllTextEB:EnableMouse(false);
		LootLink_SearchFrame_AllTextEB:SetText("");
	else
		LootLink_SearchFrame_AllTextEB:EnableMouse(true);
		LootLink_SearchFrame_AllTextEB:SetText(params.text or "");
	end
	
	
	local searchAny = self.LOCALIZATION.SEARCH_MISC_ANY;
	
	LootLink_SearchFrame_NameEB:SetFocus();
	LootLink_SearchFrame_NameEB:SetText(params.name or "");
	
	LootLink_SearchFrame_RarityDD.currID = params.rarity;
	LootLink_SearchFrame_RarityDDText:SetText(params.rarityText or searchAny);
	
	LootLink_SearchFrame_BindTypeDD.currID = params.bindType;
	LootLink_SearchFrame_BindTypeDDText:SetText(params.bindTypeText or searchAny);
	
	LootLink_SearchFrame_MinEquipLevelEB:SetText(params.minEquipLevel or "");
	LootLink_SearchFrame_MaxEquipLevelEB:SetText(params.maxEquipLevel or "");
	
	LootLink_SearchFrame_MinItemLevelEB:SetText(params.minItemLevel or "");
	LootLink_SearchFrame_MaxItemLevelEB:SetText(params.maxItemLevel or "");
	
	LootLink_SearchFrame_EquipLocationDD.currID = params.equipLocation;
	LootLink_SearchFrame_EquipLocationDDText:SetText(params.equipLocationText or searchAny);
	
	LootLink_SearchFrame_UniqueCB:SetChecked(params.unique);
	
	LootLink_SearchFrame_TypeAndSubtypeDD.currID = params.basetype;
	LootLink_SearchFrame_TypeAndSubtypeDD.subtypeID = params.subtype;
	LootLink_SearchFrame_TypeAndSubtypeDDText:SetText(
	  params.typeAndSubtypeText
	  or self.STRING_LIBRARY.format(self.LOCALIZATION.SEARCH_TYPE_SUBTYPE_ANY, searchAny)
	);
	
	
	LootLink_SearchFrame_EnableTooltipsCB:SetChecked(self.Config.SearchTooltips);
end




function LootLink:Search_ResetFields()
	local searchAny = self.LOCALIZATION.SEARCH_MISC_ANY;
	
	LootLink_SearchFrame_AllTextEB:SetText("");
	
	LootLink_SearchFrame_NameEB:SetText("");
	
	LootLink_SearchFrame_RarityDD.currID = nil;
	LootLink_SearchFrame_RarityDDText:SetText(searchAny);
	LootLink_SearchFrame_RarityDDText:SetTextColor(1.0, 1.0, 1.0);
	
	LootLink_SearchFrame_BindTypeDD.currID = nil;
	LootLink_SearchFrame_BindTypeDDText:SetText(searchAny);
	
	LootLink_SearchFrame_MinEquipLevelEB:SetText("");
	LootLink_SearchFrame_MaxEquipLevelEB:SetText("");
	
	LootLink_SearchFrame_MinItemLevelEB:SetText("");
	LootLink_SearchFrame_MaxItemLevelEB:SetText("");
	
	LootLink_SearchFrame_EquipLocationDD.currID = nil;
	LootLink_SearchFrame_EquipLocationDDText:SetText(searchAny);
	
	LootLink_SearchFrame_UniqueCB:SetChecked(nil);
	
	LootLink_SearchFrame_TypeAndSubtypeDD.currID = nil;
	LootLink_SearchFrame_TypeAndSubtypeDD.subtypeID = nil;
	LootLink_SearchFrame_TypeAndSubtypeDDText:SetText(self.STRING_LIBRARY.format(self.LOCALIZATION.SEARCH_TYPE_SUBTYPE_ANY, searchAny));
end




function LootLink:Search_AnyDDButton_OnClick()
	local button = this;
	
	local dropdownText = self.GLOBAL_ENVIRONMENT[button.owner:GetName().."Text"];
	dropdownText:SetText(button:GetText());
	dropdownText:SetTextColor(button:GetTextColor());
	
	button.owner.currID = tonumber(button.value);
	
	DropDownList1:Hide(); -- Nested dropdown buttons don't hide their parent menus on click.
end




function LootLink:Search_RarityDD_Initialize()
	local buttonInfo = self:Main_GetReusableTable(1);
	
	buttonInfo.text = self.LOCALIZATION.SEARCH_MISC_ANY;
	buttonInfo.notCheckable = true;
	buttonInfo.func = self.Search_AnyDDButton_OnClick;
	buttonInfo.arg1 = self;
	buttonInfo.owner = LootLink_SearchFrame_RarityDD;
	
	local globalEnv = self.GLOBAL_ENVIRONMENT;
	local addButton = UIDropDownMenu_AddButton;
	addButton(buttonInfo);
	
	local rarityList = ITEM_QUALITY_COLORS;
	local currentTable;
	
	for rarityNum = self.Config.MinDisplayedRarity, 6 do
		currentTable = rarityList[rarityNum];
		buttonInfo.value = rarityNum;
		buttonInfo.text = globalEnv["ITEM_QUALITY"..rarityNum.."_DESC"];
		buttonInfo.textR = currentTable.r;
		buttonInfo.textG = currentTable.g;
		buttonInfo.textB = currentTable.b;
		addButton(buttonInfo);
	end
	
	buttonInfo.value = 7;
	buttonInfo.text = UNKNOWN;
	buttonInfo.textR = 0.0;
	buttonInfo.textG = 0.8;
	buttonInfo.textB = 0.8;
	addButton(buttonInfo);
end


LootLink_SearchFrame_RarityDD.initialize = (function() LootLink:Search_RarityDD_Initialize(); end);




function LootLink:Search_BindTypeDD_Initialize()
	local buttonInfo = self:Main_GetReusableTable(1);
	
	buttonInfo.text = self.LOCALIZATION.SEARCH_MISC_ANY;
	buttonInfo.notCheckable = true;
	buttonInfo.func = self.Search_AnyDDButton_OnClick;
	buttonInfo.arg1 = self;
	buttonInfo.owner = LootLink_SearchFrame_BindTypeDD;
	
	local addButton = UIDropDownMenu_AddButton;
	addButton(buttonInfo);
	
	buttonInfo.value = -1;
	buttonInfo.text = NONE;
	addButton(buttonInfo);
	
	for bindIndex, bindTable in ipairs(self.BIND_DATA) do
		buttonInfo.value = bindIndex;
		buttonInfo.text = bindTable.name;
		addButton(buttonInfo);
	end
end


LootLink_SearchFrame_BindTypeDD.initialize = (function() LootLink:Search_BindTypeDD_Initialize(); end);




function LootLink:Search_EquipLocationDD_Initialize(level)
	if (level == 2) then
		local buttonInfo = self:Main_GetReusableTable(1);
		
		buttonInfo.notCheckable = true;
		buttonInfo.func = self.Search_AnyDDButton_OnClick;
		buttonInfo.arg1 = self;
		buttonInfo.owner = LootLink_SearchFrame_EquipLocationDD;
		
		local addButton = UIDropDownMenu_AddButton;
		
		for equipIndex, equipTable in ipairs(self.EQUIP_LOCATIONS[this:GetParent().value].subList) do
			buttonInfo.value = equipTable.value;
			buttonInfo.text = equipTable.name;
			addButton(buttonInfo, 2);
		end
		
		
	else
		local buttonInfo = self:Main_GetReusableTable(1);
		
		buttonInfo.text = self.LOCALIZATION.SEARCH_MISC_ANY;
		buttonInfo.notCheckable = true;
		buttonInfo.func = self.Search_AnyDDButton_OnClick;
		buttonInfo.arg1 = self;
		buttonInfo.owner = LootLink_SearchFrame_EquipLocationDD;
		
		local addButton = UIDropDownMenu_AddButton;
		addButton(buttonInfo);
		
		buttonInfo.value = -1;
		buttonInfo.text = NONE;
		addButton(buttonInfo);
		
		buttonInfo.hasArrow = true;
		buttonInfo.notClickable = true;
		
		for equipIndex, equipTable in ipairs(self.EQUIP_LOCATIONS) do
			buttonInfo.value = equipIndex;
			buttonInfo.text = equipTable.name;
			addButton(buttonInfo);
		end
	end
end


LootLink_SearchFrame_EquipLocationDD.initialize = (function(level) LootLink:Search_EquipLocationDD_Initialize(level); end);




function LootLink:Search_TypeAndSubtypeDDLevel1Button_OnClick()
	local button = this;
	
	local dropdown = LootLink_SearchFrame_TypeAndSubtypeDD;
	dropdown.currID = tonumber(button.value);
	dropdown.subtypeID = nil;
	
	local dropdownText = LootLink_SearchFrame_TypeAndSubtypeDDText;
	dropdownText:SetText(self.STRING_LIBRARY.format(self.LOCALIZATION.SEARCH_TYPE_SUBTYPE_ANY, button:GetText()));
	dropdownText:SetTextColor(button:GetTextColor());
end



function LootLink:Search_TypeAndSubtypeDDLevel2Button_OnClick()
	local button = this;
	
	local dropdown = LootLink_SearchFrame_TypeAndSubtypeDD;
	dropdown.currID = dropdown.selectedLevel1Button.value;
	dropdown.subtypeID = tonumber(button.value);
	
	local dropdownText = LootLink_SearchFrame_TypeAndSubtypeDDText;
	dropdownText:SetText(self.STRING_LIBRARY.format(self.LOCALIZATION.SEARCH_TYPE_SUBTYPE, dropdown.selectedLevel1Button:GetText(), button:GetText()));
	dropdownText:SetTextColor(button:GetTextColor());
	
	dropdown.selectedLevel1Button = nil;
	DropDownList1:Hide(); -- Nested dropdown buttons don't hide their parent menus on click.
end



function LootLink:Search_TypeAndSubtypeDD_Initialize(level)
	if (level == 2) then
		local button = this;
		local parent = button:GetParent();
		
		if (parent:GetName() == "DropDownList1") then
			LootLink_SearchFrame_TypeAndSubtypeDD.selectedLevel1Button = button;
		else
			LootLink_SearchFrame_TypeAndSubtypeDD.selectedLevel1Button = parent;
		end
		
		local buttonInfo = self:Main_GetReusableTable(1);
		
		buttonInfo.text = self.LOCALIZATION.SEARCH_MISC_ANY;
		buttonInfo.notCheckable = true;
		buttonInfo.func = self.Search_TypeAndSubtypeDDLevel2Button_OnClick;
		buttonInfo.arg1 = self;
		
		local addButton = UIDropDownMenu_AddButton;
		addButton(buttonInfo, 2);
		
		for subtypeIndex, subtypeTable in ipairs(self.TYPES_AND_SUBTYPES[button.hasArrow or parent.hasArrow].subList) do
			buttonInfo.value = subtypeTable.value;
			buttonInfo.text = subtypeTable.displayName;
			addButton(buttonInfo, 2);
		end
		
		
	else
		local buttonInfo = self:Main_GetReusableTable(1);
		
		buttonInfo.text = self.LOCALIZATION.SEARCH_MISC_ANY;
		buttonInfo.notCheckable = true;
		buttonInfo.func = self.Search_TypeAndSubtypeDDLevel1Button_OnClick;
		buttonInfo.arg1 = self;
		
		local addButton = UIDropDownMenu_AddButton;
		addButton(buttonInfo);
		
		for typeIndex, typeTable in ipairs(self.TYPES_AND_SUBTYPES) do
			buttonInfo.value = typeTable.value;
			buttonInfo.text = typeTable.displayName;
			if (typeTable.subList) then
				buttonInfo.hasArrow = typeIndex;
			else
				buttonInfo.hasArrow = nil;
			end
			addButton(buttonInfo);
		end
	end
end


LootLink_SearchFrame_TypeAndSubtypeDD.initialize = (function(level) LootLink:Search_TypeAndSubtypeDD_Initialize(level); end);




function LootLink:Search_SaveValues()
	local params = self.SearchParameters;
	
	for key in pairs(params) do
		params[key] = nil;
	end
	
	
	local value = LootLink_SearchFrame_AllTextEB:GetText();
	if (value ~= "") then params.text = value; end
	
	value = LootLink_SearchFrame_NameEB:GetText();
	if (value ~= "") then params.name = value; end
	
	
	value = LootLink_SearchFrame_RarityDD.currID;
	if (value) then params.rarity = value; params.rarityText = LootLink_SearchFrame_RarityDDText:GetText(); end
	
	value = LootLink_SearchFrame_BindTypeDD.currID;
	if (value) then params.bindType = value; params.bindTypeText = LootLink_SearchFrame_BindTypeDDText:GetText(); end
	
	
	params.minEquipLevel = tonumber(LootLink_SearchFrame_MinEquipLevelEB:GetText());
	params.maxEquipLevel = tonumber(LootLink_SearchFrame_MaxEquipLevelEB:GetText());
	
	params.minItemLevel = tonumber(LootLink_SearchFrame_MinItemLevelEB:GetText());
	params.maxItemLevel = tonumber(LootLink_SearchFrame_MaxItemLevelEB:GetText());
	
	
	value = LootLink_SearchFrame_EquipLocationDD.currID;
	if (value) then params.equipLocation = value; params.equipLocationText = LootLink_SearchFrame_EquipLocationDDText:GetText(); end
	
	params.unique = LootLink_SearchFrame_UniqueCB:GetChecked();
	
	
	value = LootLink_SearchFrame_TypeAndSubtypeDD.currID;
	if (value) then
		params.basetype = value;
		params.typeAndSubtypeText = LootLink_SearchFrame_TypeAndSubtypeDDText:GetText();
		
		value = LootLink_SearchFrame_TypeAndSubtypeDD.subtypeID;
		if (value) then params.subtype = value; end
	end
end




local function LootLink_Search_SaveAndUpdate(self)
	PlaySound("gsTitleOptionOk");
	
	LootLink:Search_SaveValues();
	LootLink:Results_FullRebuild();
end



LootLink_SearchFrame_SearchButton:SetScript("OnClick", LootLink_Search_SaveAndUpdate);

LootLink_SearchFrame_AllTextEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);
LootLink_SearchFrame_NameEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);

LootLink_SearchFrame_MinEquipLevelEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);
LootLink_SearchFrame_MaxEquipLevelEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);

LootLink_SearchFrame_MinItemLevelEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);
LootLink_SearchFrame_MaxItemLevelEB:SetScript("OnEnterPressed", LootLink_Search_SaveAndUpdate);




function LootLink:Search_ShowHelpTooltipForElement(element)
	if (self.Config.SearchTooltips) then
		GameTooltip:SetOwner(element, "ANCHOR_RIGHT");
		GameTooltip:SetText(self.LOCALIZATION.SEARCH_TOOLTIPS[element:GetName()], 1.0, 0.82, 0.0, true, true);
	end
end

