

local LootLink = LootLink;




--TOOLTIP_UPDATE_TIME = 0.9; -- This is originally 0.2, which is unnecessarily fast since the tooltips's cooldown line does not count down in less than full seconds.



--GameTooltip.LootLink_Original_metatable_index = getmetatable(GameTooltip).__index;


do
	local tooltip = GameTooltip;
	
	tooltip.LootLink_Original_SetAuctionItem = tooltip.SetAuctionItem;
	tooltip.LootLink_Original_SetBagItem = tooltip.SetBagItem;
	tooltip.LootLink_Original_SetCraftItem = tooltip.SetCraftItem;
	tooltip.LootLink_Original_SetInboxItem = tooltip.SetInboxItem;
	tooltip.LootLink_Original_SetInventoryItem = tooltip.SetInventoryItem;
	tooltip.LootLink_Original_SetLootItem = tooltip.SetLootItem;
	tooltip.LootLink_Original_SetLootRollItem = tooltip.SetLootRollItem;
	tooltip.LootLink_Original_SetMerchantItem = tooltip.SetMerchantItem;
	tooltip.LootLink_Original_SetQuestItem = tooltip.SetQuestItem;
	tooltip.LootLink_Original_SetQuestLogItem = tooltip.SetQuestLogItem;
	tooltip.LootLink_Original_SetSendMailItem = tooltip.SetSendMailItem;
	tooltip.LootLink_Original_SetTradePlayerItem = tooltip.SetTradePlayerItem;
	tooltip.LootLink_Original_SetTradeTargetItem = tooltip.SetTradeTargetItem;
	tooltip.LootLink_Original_SetTradeSkillItem = tooltip.SetTradeSkillItem;
	tooltip.LootLink_Original_SetGuildBankItem = tooltip.SetGuildBankItem;
end


--GameTooltipMoneyFrame.LootLink_Original_OnHide = GameTooltipMoneyFrame:GetScript("OnHide");



ItemRefTooltip.LootLink_Original_SetHyperlink = ItemRefTooltip.SetHyperlink;




function LootLink:Tooltips_AddAllApplicableInfo(itemLink, tooltip, quantity, skipPrice)
	if (type(itemLink) == "number") then
		local itemName;
		itemName, itemLink = GetItemInfo(itemLink);
	end
	
	if (not itemLink) then return; end
	
	
	local stringsub = self.STRING_LIBRARY.sub;
	
	local config = self.Config;
	local localization = self.LOCALIZATION;
	
	local tooltipSettings = tostring(config.TooltipSettings[tooltip:GetName()] or "1111111");
	
	local baseID, enchantID, gem1ID, gem2ID, gem3ID, socketBonusID, suffixID, instanceID = itemLink:match(
	  "item:(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)"
	);
	
	if (not baseID) then
		baseID, enchantID, suffixID, instanceID = itemLink:match("item:(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)");
	end
	
	
	local r, g, b = 0.0, 0.8, 0.8;
	
	if (stringsub(tooltipSettings, 7, 7) == "2") then
		r, g, b = 1.0, 1.0, 1.0;
	end
	
	
	if (stringsub(tooltipSettings, 6, 6) == "2") then
		tooltip:AddLine("-=-=-=-=-=-=-=-=-", r, g, b);
	end
	
	
	if (baseID) then
		baseID = tonumber(baseID);
		
		local itemTable = tooltip.LootLink_LastAppliedItemTable;
		
		if (not itemTable or itemTable[-1] ~= baseID) then
			itemTable = self.Database[baseID];
			tooltip.LootLink_LastAppliedItemTable = itemTable;
		end
		
		
		if (not skipPrice and stringsub(tooltipSettings, 1, 1) == "2") then
			self:Tooltips_AddVendorValue(itemTable, tooltip, quantity, r, g, b);
		end
		
		
		if (stringsub(tooltipSettings, 2, 2) == "2") then
			local _, _, _, itemLevel = GetItemInfo(baseID);
			tooltip:AddLine(localization.TOOLTIP_ITEM_LEVEL:format(itemLevel or (itemTable and itemTable[12]) or localization.GENERIC_UNKNOWN), r, g, b);
		end
		
		
		if (stringsub(tooltipSettings, 3, 3) == "2") then
			tooltip:AddLine(localization.TOOLTIP_IDS_BASIC:format(baseID, enchantID, suffixID, instanceID), r, g, b);
		end
		
		
		if (gem1ID and stringsub(tooltipSettings, 4, 4) == "2") then
			tooltip:AddLine(localization.TOOLTIP_IDS_SOCKETS:format(gem1ID, gem2ID, gem3ID, socketBonusID), r, g, b);
		end
		
		
		if (stringsub(tooltipSettings, 5, 5) == "2") then
			local lastSeen = self.LastSeenOnServerForCurrentRealm[baseID];
			
			tooltip:AddLine(
			  localization.TOOLTIP_LAST_SEEN:format(
				(self.Config.TrackLastSeen and ((lastSeen and date(nil, lastSeen)) or localization.GENERIC_NEVER))
				or localization.TOOLTIP_SEEN_NOT_TRACKED
			  ),
			  r, g, b
			);
		end
		
		
		if (stringsub(tooltipSettings, 8, 8) == "2") then
			local maxStack = select(8,GetItemInfo(baseID));
			
			if (maxStack and maxStack > 1) then
				tooltip:AddLine(localization.TOOLTIP_MAX_STACK:format(maxStack or localization.GENERIC_UNKNOWN), r, g, b);
			end
		end
		
		
		if (not GetItemInfo(baseID)) then
			tooltip:AddLine(localization.TOOLTIP_GENERATED_FROM_CACHE, r, g, b);
		end
		
		
	else
		local enchantSpellID = itemLink:match("enchant:(%d+)");
		
		if (enchantSpellID and stringsub(tooltipSettings, 2, 2) == "2") then
			tooltip:AddLine(localization.TOOLTIP_IDS_ENCHANTSPELL:format(enchantSpellID), r, g, b);
		end
	end
	
	
	tooltip:Show();
end

--Implement GetSellValue API: http://www.wowwiki.com/API_GetSellValue
local origGetSellValue = GetSellValue
function GetSellValue(baseID)
	if not baseID then return nil end
	
	if (type(baseID) ~= "number") then
		local link = select(2,GetItemInfo(item))
		if not link then return end
		baseID = tonumber( string.match(link, "item:(%d+)") )
	end

	--If we have a price recorded...
	if LootLink.Database[baseID] and (LootLink.Database[baseID][6] ~= nil) then
		local price = LootLink.Database[baseID][6];
		if price == false then
			return 0
		else
			return price
		end
	elseif origGetSellValue then 
		return origGetSellValue(baseID)
	else
		return nil
	end
end

function LootLink:Tooltips_AddVendorValue(baseID, tooltip, quantity, r, g, b)
	local linkTable;
	
	if (type(baseID) == "table") then
		linkTable = baseID;
		baseID = linkTable[-1];
	else
		linkTable = self.Database[tonumber(baseID)];
	end
	
	if (not linkTable or not baseID) then return nil, nil; end
	
	
	if (not r and not g and not b) then
		if ((self.Config.TooltipSettings[tooltip:GetName()] or "1111111"):sub(7, 7) == "2") then
			r, g, b = 1.0, 1.0, 1.0;
		else
			r, g, b = 0.0, 0.8, 0.8;
		end
	end
	
	
	if (quantity and quantity > 0) then
		quantity = self.MATH_LIBRARY.ceil(quantity);
	else
		quantity = 1;
	end
	
	
	local maxStack = select(8,GetItemInfo(baseID));

--[[
	if (maxStack == 1 or not maxStack) then
		tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE, r, g, b);
	else
		tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE_FOR_NUM:format(quantity), r, g, b);
	end
]]--
	
--	local price = linkTable[6];
	local price = GetSellValue(baseID)

	local globalEnv = self.GLOBAL_ENVIRONMENT;
	
	local name = tooltip:GetName();
	local moneyLine = globalEnv[name.."TextLeft"..tooltip:NumLines()];

	if (price) then
		if price == 0 then -- This item has been verified as not sellable, so display that.
			if (maxStack == 1 or not maxStack) then
				tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE, r, g, b);
			else
				tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE_FOR_NUM:format(quantity), r, g, b);
			end
			local moneyLine = globalEnv[name.."TextLeft"..tooltip:NumLines()];
			moneyLine:SetText(
				moneyLine:GetText()
				.." "
				..self.LOCALIZATION.GENERIC_NONE
			);
		else
			-- Add a little yellow to make these more vibrant.
--[[			globalEnv[name.."MoneyFrameCopperButtonText"]:SetTextColor(r + 0.25, g + 0.2, b);
			globalEnv[name.."MoneyFrameSilverButtonText"]:SetTextColor(r + 0.25, g + 0.2, b);
			globalEnv[name.."MoneyFrameGoldButtonText"]:SetTextColor(r + 0.25, g + 0.2, b);
]]--
			SetTooltipMoney(tooltip, (price * quantity));
			local moneyFrame = getglobal(name.."MoneyFrame"..tooltip.shownMoneyFrames);
			local moneyLine = globalEnv[name.."TextLeft"..tooltip:NumLines()];
			moneyFrame:SetPoint("LEFT", moneyLine, "RIGHT", 4, 0);
			if (maxStack == 1 or not maxStack) then
				moneyLine:SetText(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE);
			else
				moneyLine:SetText(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE_FOR_NUM:format(quantity));
			end
			moneyLine:SetTextColor(r, g, b);
			tooltip:SetMinimumWidth(moneyFrame:GetWidth() + moneyLine:GetWidth() - 10);
		end
	else
		if (maxStack == 1 or not maxStack) then
			tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE, r, g, b);
		else
			tooltip:AddLine(self.LOCALIZATION.TOOLTIP_VENDOR_VALUE_FOR_NUM:format(quantity), r, g, b);
		end
		local moneyLine = globalEnv[name.."TextLeft"..tooltip:NumLines()];
		moneyLine:SetText(
		  moneyLine:GetText()
		  .." "
		  ..self.LOCALIZATION.GENERIC_UNKNOWN
		);
	end
	
	
	tooltip:Show();
	
	
	return price, moneyLine;
end




ItemRefTooltip.SetHyperlink = function(tooltip, hyperlink, ...)
	tooltip.LootLink_Original_SetHyperlink(tooltip, hyperlink, ...);
	
	LootLink:Tooltips_AddAllApplicableInfo(hyperlink, tooltip, 1);
end




GameTooltip.SetAuctionItem = function(self, auctionType, index, ...)
	self.LootLink_Original_SetAuctionItem(self, auctionType, index, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetAuctionItemInfo(auctionType, index);
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetBagItem = function(self, ...)
	--local bag = select(1, ...)
	--local slot = select(2, ...)
	local _, _ = self.LootLink_Original_SetBagItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, quantity = GetContainerItemInfo(select(1, ...), select(2, ...));
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity, (MerchantFrame:IsShown() and MerchantFrame.selectedTab == 1));
	end
	
	return coolingDown, repairCost;
end




GameTooltip.SetCraftItem = function(self, ...)
	self.LootLink_Original_SetCraftItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetCraftReagentInfo(select(1, ...), select(2, ...));
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetInboxItem = function(self, ...)
	self.LootLink_Original_SetInboxItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetInboxItem( select(1, ...), select(2, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetInventoryItem = function(self, ...)
	local hasItem, hasCooldown, repairCost = self.LootLink_Original_SetInventoryItem(self, ...);
	local unit = select(1, ...)
	local slot = select(2, ...)
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		if (slot > 17 and slot < 24) then
			-- This is a bag. GetInventoryItemCount will return the number of slots instead of 1.
			LootLink:Tooltips_AddAllApplicableInfo(link, self, 1);
		else
			LootLink:Tooltips_AddAllApplicableInfo(link, self, GetInventoryItemCount(unit, slot));
		end
	end
	
	return hasItem, hasCooldown, repairCost;
end




GameTooltip.SetLootItem = function(self, ...)
	self.LootLink_Original_SetLootItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetLootSlotInfo( select(1, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetLootRollItem = function(self, ...)
	self.LootLink_Original_SetLootRollItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetLootRollItemInfo( select(1, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetMerchantItem = function(self, ...)
	self.LootLink_Original_SetMerchantItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, _, quantity = GetMerchantItemInfo( select(1, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetQuestItem = function(self, ...)
	self.LootLink_Original_SetQuestItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetQuestItemInfo( select(1, ...), select(2, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetQuestLogItem = function(self, ...)
	self.LootLink_Original_SetQuestLogItem(self, ...);
	
	local _, link = self:GetItem();
	if (link) then
		local _, _, quantity = GetQuestLogRewardInfo( select(2, ...) );
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetSendMailItem = function(self, ...)
	self.LootLink_Original_SetSendMailItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetSendMailItem();
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end




GameTooltip.SetTradePlayerItem = function(self, ...)
	self.LootLink_Original_SetTradePlayerItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetTradePlayerItemInfo( select(1, ...) );
		if (quantity > 0) then
			LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
		end
	end
end




GameTooltip.SetTradeTargetItem = function(self, ...)
	self.LootLink_Original_SetTradeTargetItem(self, ...);
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		local _, _, quantity = GetTradeTargetItemInfo( select(1, ...) );
		if (quantity > 0) then
			LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
		end
	end
end




GameTooltip.SetTradeSkillItem = function(self, ...)
	self.LootLink_Original_SetTradeSkillItem(self, ...);
	local selectedSkill = select(1, ...)
	local id = select(2, ...)
	
	local _, link = self:GetItem();
	if (link ~= nil) then
		if (id) then
			local _, _, quantity = GetTradeSkillReagentInfo(selectedSkill, id);
			LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
		else
			local minMade, maxMade = GetTradeSkillNumMade(selectedSkill);
			LootLink:Tooltips_AddAllApplicableInfo(link, self, LootLink.MATH_LIBRARY.ceil(((minMade or 2) + (maxMade or 0)) / 2));
		end
	end
end




GameTooltip.SetGuildBankItem = function(self, ...)
	self.LootLink_Original_SetGuildBankItem(self, ...);

	local _, link = self:GetItem();
	if (link) then
		local _,  quantity = GetGuildBankItemInfo( select(1, ...), select(2, ...) )
		LootLink:Tooltips_AddAllApplicableInfo(link, self, quantity);
	end
end



--[[
GameTooltipMoneyFrame:SetScript("OnHide",
  function(self, ...)
	self.LootLink_Original_OnHide(self, ...);
	
	GameTooltipMoneyFrameCopperButtonText:SetTextColor(1.0, 1.0, 1.0);
	GameTooltipMoneyFrameSilverButtonText:SetTextColor(1.0, 1.0, 1.0);
	GameTooltipMoneyFrameGoldButtonText:SetTextColor(1.0, 1.0, 1.0);
  end
);
]]--



--[[
function LootLink.ReplaceHook_AnyTooltip_metatable_index(tooltip, key)
	local meta = rawget(tooltip, "LootLink_Original_metatable_index");
	
	if (meta) then
		returnVal = meta[key];
	else
		PrintComma(key);
	end
	
	
	if (
	  key ~= "IsOwned" and (
	    key == "SetInventoryItem" or key == "SetAuctionItem"
	    or key == "SetBagItem" or key == "SetCraftItem" or key == "SetLootItem"
	    or key == "SetMerchantItem" or key == "SetQuestItem" or key == "SetQuestLogItem"
	    or key == "SetTradePlayerItem" or key == "SetTradeTargetItem"
	    or key == "SetTradeSkillItem" or key == "Hide"
	  )
	) then
		tooltip.LootLink_WrappedMethodName = key;
		returnVal = LootLink.PostHook_AnyTooltip_AnyMethod;
	end
	
	
	return returnVal;
end


getmetatable(GameTooltip).__index = LootLink.ReplaceHook_AnyTooltip_metatable_index;




function LootLink.PostHook_AnyTooltip_AnyMethod(tooltip, ...)
	local realMethod = tooltip.LootLink_WrappedMethodName;
	
	local retVal1, retVal2, retVal3, retVal4, retVal5, retVal6 = tooltip[realMethod](tooltip, ...);
	
	
	if (realMethod == "SetInventoryItem") then
		local link = GetInventoryItemLink(...);
		
		if (link) then
			if (slot > 17 and slot < 24) then
				-- This is a bag. GetInventoryItemCount will return the number of slots instead of 1.
				LootLink:Tooltips_AddAllApplicableInfo(link, tooltip, 1);
			else
				LootLink:Tooltips_AddAllApplicableInfo(link, tooltip, GetInventoryItemCount(...));
			end
		end
		
		
	elseif (realMethod == "SetAuctionItem") then
		local _, _, quantity = GetAuctionItemInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetAuctionItemLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetBagItem") then
		local texture, quantity = GetContainerItemInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetContainerItemLink(...), tooltip, quantity, (MerchantFrame:IsShown() and MerchantFrame.selectedTab == 1));
		
		
	elseif (realMethod == "SetCraftItem") then
		local _, _, quantity = GetCraftReagentInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetCraftReagentItemLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetLootItem") then
		local _, _, quantity = GetLootSlotInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetLootSlotLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetMerchantItem") then
		local _, _, _, quantity = GetMerchantItemInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetMerchantItemLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetQuestItem") then
		local _, _, quantity = GetQuestItemInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetQuestItemLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetQuestLogItem") then
		local _, _, quantity = GetQuestLogRewardInfo(...);
		LootLink:Tooltips_AddAllApplicableInfo(GetQuestLogItemLink(...), tooltip, quantity);
		
		
	elseif (realMethod == "SetTradePlayerItem") then
		local _, _, quantity = GetTradePlayerItemInfo(...);
		if (quantity > 0) then
			LootLink:Tooltips_AddAllApplicableInfo(GetTradePlayerItemLink(...), tooltip, quantity);
		end
		
		
	elseif (realMethod == "SetTradeTargetItem") then
		local _, _, quantity = GetTradeTargetItemInfo(...);
		if (quantity > 0) then
			LootLink:Tooltips_AddAllApplicableInfo(GetTradeTargetItemLink(...), tooltip, quantity);
		end
		
		
	elseif (realMethod == "SetTradeSkillItem") then
		if (select(2, ...)) then
			local _, _, quantity = GetTradeSkillReagentInfo(...);
			LootLink:Tooltips_AddAllApplicableInfo(GetTradeSkillReagentItemLink(...), tooltip, quantity);
			
		else
			local minMade, maxMade = GetTradeSkillNumMade(...);
			LootLink:Tooltips_AddAllApplicableInfo(GetTradeSkillItemLink(...), tooltip, LootLink.MATH_LIBRARY.ceil(((minMade or 2) + (maxMade or 0)) / 2));
		end
		
		
	elseif (realMethod == "Hide") then
		local globalEnv = LootLink.GLOBAL_ENVIRONMENT;
		
		globalEnv[tooltipName.."MoneyFrameCopperButtonText"]:SetTextColor(1.0, 1.0, 1.0);
		globalEnv[tooltipName.."MoneyFrameSilverButtonText"]:SetTextColor(1.0, 1.0, 1.0);
		globalEnv[tooltipName.."MoneyFrameGoldButtonText"]:SetTextColor(1.0, 1.0, 1.0);
	end
	
	
	return retVal1, retVal2, retVal3, retVal4, retVal5, retVal6;
end
]]--

