

function LootLink:AuctionScanning_Initialize()


self:AuctionScanning_InitializeLocalization();

self.AuctionScanning_InitializeLocalization = nil;




local LootLink = self;
local oncePerPage = false
local queriedFullList = false




do
	local frame = CreateFrame("Frame", "LootLink_AuctionScanning_OnUpdateFrame", WorldFrame);
	
	
	frame:Hide();
	
	
	frame.LOOTLINK = LootLink;
	
	self.AUCTIONSCANNING_ON_UPDATE_FRAME = frame;
end




function LootLink:AuctionScanning_StartScan()
	self.AuctionScanDatabaseSize = self.DatabaseSize;
	self.CurrentAuctionPage = 0;
	self.AUCTIONSCANNING_ON_UPDATE_FRAME.Elapsed = 0.0;

	
	BrowseSearchButton:Hide();
  BrowseResetButton:Hide();
	
	BrowseName:SetText(self.LOCALIZATION.AUCTIONSCANNING_BROWSEBOX_SEARCHING);
	BrowseName:EnableMouse(false);
	
	BrowseMinLevel:EnableMouse(false);
	BrowseMinLevel:SetText("");
	BrowseMaxLevel:EnableMouse(false);
	BrowseMaxLevel:SetText("");
	
	BrowseNoResultsText:SetText(self.LOCALIZATION.AUCTIONSCANNING_SCAN_BEGINNING);

	AuctionFrameBrowse:UnregisterEvent("AUCTION_ITEM_LIST_UPDATE");

--	self.AUCTIONSCANNING_ON_UPDATE_FRAME:Show();

--	if select(2, CanSendAuctionQuery()) then -- 1 if can query, nil otherwise
--		queriedFullList = true
--	else
		queriedFullList = nil
--	end
	QueryAuctionItems("", "", "", nil, nil, nil, 0, nil, nil, queriedFullList);

	self.AUCTIONSCANNING_ON_UPDATE_FRAME:Show();
end

--/script if QueryAuctionItems then DEFAULT_CHAT_FRAME:AddMessage("YES") end
--/script QueryAuctionItems("", "", "", nil, nil, nil, nil, nil, nil, true)
--/script if (select(2, CanSendAuctionQuery()) ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("Yes") end
--/script DEFAULT_CHAT_FRAME:AddMessage(type(select(2, CanSendAuctionQuery())))
--/script DEFAULT_CHAT_FRAME:AddMessage(select(2, CanSendAuctionQuery()))

--/script DEFAULT_CHAT_FRAME:AddMessage(GetMerchantNumItems())


function LootLink:AuctionScanning_StopScan()
	--[[ Database size can expand after the scan has completed but before the auction window is closed.
	To avoid an inaccurate count of new items from this scan, we only set this once, when the scan first completes. ]]--
	self.AuctionScanDatabaseSize = (self.DatabaseSize - self.AuctionScanDatabaseSize);
	
	self.CurrentAuctionPage = nil;
	self.AUCTIONSCANNING_ON_UPDATE_FRAME.Elapsed = nil;
	
	
	BrowseSearchButton:Show();
	BrowseResetButton:Show();

	BrowseName:SetText("");
	BrowseName:EnableMouse(true);
	
	BrowseMinLevel:EnableMouse(true);
	BrowseMaxLevel:EnableMouse(true);
	
--	if queriedFullList then
		AuctionFrameBrowse:RegisterEvent("AUCTION_ITEM_LIST_UPDATE");
--		queriedFullList = nil
--	end

	
	self.AUCTIONSCANNING_ON_UPDATE_FRAME:Hide();
	BrowseNoResultsText:SetText(self.LOCALIZATION.AUCTIONSCANNING_NEW_ITEMS_SHORT:format(self.AuctionScanDatabaseSize));
end




function LootLink:AuctionScanning_OnAuctionHouseClosed()
	self.DoAuctionScan = nil;
	
	if (self.CurrentAuctionPage) then
		-- Auction frame was closed while we were still scanning. Stop the scan.
		self:AuctionScanning_StopScan();
	end
	
	DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.AUCTIONSCANNING_NEW_ITEMS_LONG:format(self.AuctionScanDatabaseSize), 0.0, 0.8, 0.8);
	
	self.AuctionScanDatabaseSize = nil;
end




LootLink.AUCTIONSCANNING_ON_UPDATE_FRAME:SetScript("OnUpdate", function(self, elapsed)
	self.Elapsed = (self.Elapsed + elapsed);
	
	if select(1, CanSendAuctionQuery()) then
		if oncePerPage == false then
--			DEFAULT_CHAT_FRAME:AddMessage("CanSendAuctionQuery after: "..self.Elapsed)
			oncePerPage = true
		end
		if queriedFullList then
			if (self.Elapsed > 5) then
				self.Elapsed = 0.0;

				self.LOOTLINK:AuctionScanning_StopScan();
			end
		else
			if (self.Elapsed > 1.1) then -- In general, the delay between potential searches is about five seconds.
				self.Elapsed = 0.0;

				self.LOOTLINK:AuctionScanning_NextPage();
			end
		end
	end
end);




function LootLink:AuctionScanning_NextPage()
	oncePerPage = false

	local numBatchAuctions, totalAuctions = GetNumAuctionItems("list");

	local maxPages = self.MATH_LIBRARY.floor(totalAuctions / NUM_AUCTION_ITEMS_PER_PAGE);

	local page = self.CurrentAuctionPage;

	if (page and page < maxPages) then
		self.CurrentAuctionPage = (page + 1);
		BrowseNoResultsText:SetText(self.LOCALIZATION.AUCTIONSCANNING_PAGE_OF_TOTAL:format((page + 2), (maxPages + 1)));
		QueryAuctionItems("", "", "", nil, nil, nil, self.CurrentAuctionPage, nil, nil, false);
	else
		self:AuctionScanning_StopScan();
	end
end




end

