

function LootLink:AutoLinkBot_Initialize()


self:AutoLinkBot_InitializeLocalization();

self.AutoLinkBot_InitializeLocalization = nil;




local LootLink = self;




LootLink.AUTOLINKBOT_NUM_LINKS_PER_MESSAGE = 3;



LootLink.AUTOLINKBOT_MAX_PRIVATE_MATCHES = 9;


LootLink.AUTOLINKBOT_MAX_PUBLIC_MATCHES = 1;



if (LootLink.Original_ChatFrame_MessageEventHandler == nil) then
	LootLink.Original_ChatFrame_MessageEventHandler = ChatFrame_MessageEventHandler;
	ChatFrame_MessageEventHandler = LootLink.ReplaceHook_ChatFrame_MessageEventHandler;
end


local LL_LastParseTime = 0
local LL_HaveSentWarning = nil

function LootLink:AutoLinkBot_ParseRequest(message, requester, chatEvent)
  local sendChatMessage = SendChatMessage;
  local chatType = chatEvent:match("^CHAT_MSG_([^_]+)"); -- Use "[^_]+" to match "CHAT_MSG_WHISPER_INFORM" as "WHISPER" instead of "WHISPER_INFORM".
  if (not self.Config.AutoLinkBotWatchedChannels[chatType]) then return; end

  local publicOrPrivate, itemName = message:match(self.LOCALIZATION.AUTOLINKBOT_REQUEST_FORMAT);
  if (not itemName or itemName:len() < self.Config.AutoLinkBotMinLength) then return; end

  local maxMatches;
  if (publicOrPrivate == "!") then
    chatType = ("WHISPER");
    maxMatches = self.AUTOLINKBOT_MAX_PRIVATE_MATCHES;
  else
    maxMatches = self.AUTOLINKBOT_MAX_PUBLIC_MATCHES;
  end

  if (LL_LastParseTime + 2) > ( tonumber( date("%S") ) + (60 * tonumber( date("%M") )) + (60 * 60 * tonumber( date("%H") )) ) then
    if not LL_HaveSentWarning then
      sendChatMessage("Please wait at least 2 seconds between AutoLinkBot queries.", chatType, nil, requester)
      LL_HaveSentWarning = true
    end
  else
    LL_HaveSentWarning = nil
    LL_LastParseTime = tonumber( date("%S") ) + (60 * tonumber( date("%M") )) + (60 * 60 * tonumber( date("%H") ))

    self:AutoLinkBot_SendResponseLinks(chatType, requester, itemName, maxMatches);
  end
end




function LootLink:AutoLinkBot_SendResponseLinks(chatType, requester, itemName, maxLinks)
	local stringconcat = self.STRING_LIBRARY.concat;
	local stringformat = self.STRING_LIBRARY.format;
	local getItemInfo = GetItemInfo;
	local sendChatMessage = SendChatMessage;
	
	local numLinksPerMessage = self.AUTOLINKBOT_NUM_LINKS_PER_MESSAGE;
	
	local numLinksSent = 0;
	local numLinksInMessage = 0;
	local _, link;
	
	
	local linksTable, numMatches = self:Matching_ByCached(self:Main_GetReusableTable(1), true, nil);
	linksTable, numMatches = self:Matching_ByCharsInName(linksTable, false, nil, itemName, true, true);
	
	if (numMatches > maxLinks) then
		self:Matching_LimitMatchesToNum(linksTable, maxLinks);
	end
	
	
	local prefix = stringformat(self.LOCALIZATION.AUTOLINKBOT_OUTGOING_CHAT_PREFIX, itemName, numMatches);
	local message = prefix;
	
	
	for baseID, itemTable in pairs(linksTable) do
		_, link = getItemInfo(baseID);
		message = stringconcat(message, link, " ");
		
		numLinksSent = (numLinksSent + 1);
		numLinksInMessage = (numLinksInMessage + 1);
		
		if (numLinksInMessage == numLinksPerMessage) then
			numLinksInMessage = 0;
			sendChatMessage(message, chatType, nil, requester);
			message = prefix;
		end
	end
	
	
	if (numLinksSent ~= 0) then
		if (numLinksInMessage ~= 0) then
			-- The number of matching items was not divisible by the number of links per message, so the final message was not sent via the loop. Send it now.
			sendChatMessage(message, chatType, nil, requester);
		end
	else
		sendChatMessage(prefix..self.LOCALIZATION.AUTOLINKBOT_NO_RESULTS, chatType, nil, requester);
	end
	
	
	return numLinksSent;
end




end

