

function LootLink:Options_Initialize()


self:Options_InitializeXML();

self.Options_InitializeXML = nil;


self:Options_InitializeLocalization();

self.Options_InitializeLocalization = nil;




local LootLink = self;



LootLink_Options_TooltipSettingsDDText:SetJustifyH("CENTER");
LootLink_Options_MinStoredRarityDDText:SetJustifyH("CENTER");
LootLink_Options_MinDisplayedRarityDDText:SetJustifyH("CENTER");



LootLink.TempTooltipSettings = {};




function LootLink:Options_ShowHelpTooltipForElement(element)
	local tooltip = GameTooltip;
	tooltip:SetOwner(element, "ANCHOR_RIGHT");
	tooltip:SetText(self.LOCALIZATION.OPTIONS_TOOLTIPS[element:GetName()], 1.0, 0.82, 0.0, true, true);
end




function LootLink:Options_LoadValues(config)
	if (not config) then
		config = self.Config;
	end
	
	
	LootLink_Options_LightModeCB:SetChecked(config.LightMode);
	
	LootLink_Options_EnableQuickSearchCB:SetChecked(config.EnableQuickSearch);
	LootLink_Options_AutoFocusQuickSearchCB:SetChecked(config.AutoFocusQuickSearch);
	
	LootLink_Options_MobilizeResultsCB:SetChecked(config.MobilizeResults);
	
	LootLink_Options_TrackLastSeenCB:SetChecked(config.TrackLastSeen);
	
	LootLink_Options_StoreItemTexturePathCB:SetChecked(config.StoreItemTexturePath);
	
	LootLink_Options_EnableToggleButtonCB:SetChecked(config.EnableToggleButton);
	
	
	local tempSettings = self.TempTooltipSettings;
	
	for tooltipName, tooltipSettings in pairs(config.TooltipSettings) do
		tempSettings[tooltipName] = tooltipSettings;
	end
	
	LootLink_Options_EnableQuickChatlinkCB:SetChecked(config.EnableQuickChatlink);
	LootLink_Options_NoQuickChatlinkForSlashCommandsCB:SetChecked(config.NoQuickChatlinkForSlashCommands);
	LootLink_Options_NoSuggestionsForQuickChatlinkCB:SetChecked(config.NoSuggestionsForQuickChatlink);
	
	LootLink_Options_EnableSlashLLCB:SetChecked(config.EnableSlashLL);
	
	
	LootLink_Options_EnableAutoLinkBotCB:SetChecked(config.EnableAutoLinkBot);
	LootLink_Options_AutoLinkBotMinLengthEB:SetText(config.AutoLinkBotMinLength);
	
	tempSettings = {};
	self.TempAutoLinkBotWatchedChannels = tempSettings;
	
	for channelName in pairs(config.AutoLinkBotWatchedChannels) do
		tempSettings[channelName] = true;
	end
	
	
	LootLink_Options_EnableDataSharingCB:SetChecked(config.EnableDataSharing);
	
	tempSettings = {};
	self.TempDataSharingBroadcastChannels = tempSettings;
	
	for channelName in pairs(config.DataSharingBroadcastChannels) do
		tempSettings[channelName] = true;
	end
	
	
	local rarityTable = ITEM_QUALITY_COLORS[config.MinStoredRarity];
	
	LootLink_Options_MinStoredRarityDD.currID = config.MinStoredRarity;
	
	LootLink_Options_MinStoredRarityDDText:SetText(getglobal("ITEM_QUALITY"..config.MinStoredRarity.."_DESC"));
	LootLink_Options_MinStoredRarityDDText:SetTextColor(rarityTable.r, rarityTable.g, rarityTable.b);
	
	
	rarityTable = ITEM_QUALITY_COLORS[config.MinDisplayedRarity];
	
	LootLink_Options_MinDisplayedRarityDD.currID = config.MinDisplayedRarity;
	
	LootLink_Options_MinDisplayedRarityDDText:SetText(getglobal("ITEM_QUALITY"..config.MinDisplayedRarity.."_DESC"));
	LootLink_Options_MinDisplayedRarityDDText:SetTextColor(rarityTable.r, rarityTable.g, rarityTable.b);
end


self.OPTIONS_DISPLAY_FRAME:SetScript("OnShow", (function(self) self.LOOTLINK:Options_LoadValues(); end));




function LootLink:Options_SaveValues(config)
	if (not config) then
		config = self.Config;
	end
	
	
	if (LootLink_Options_LightModeCB:GetChecked()) then
		if (not config.LightMode) then
			-- This is a major event, so it has a confirmation.
			StaticPopup_Show("LOOTLINK_CONFIRM_LIGHTMODE");
		end
		
	elseif (config.LightMode) then
		config.LightMode = nil;
		DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.OPTIONS_LIGHT_MODE_DISABLED, 0.0, 0.8, 0.8);
	end
	
	
	if (LootLink_Options_EnableQuickSearchCB:GetChecked()) then config.EnableQuickSearch = true; else config.EnableQuickSearch = nil; end
	
	if (LootLink_Options_AutoFocusQuickSearchCB:GetChecked()) then config.AutoFocusQuickSearch = true; else config.AutoFocusQuickSearch = nil; end
	
	
	if (LootLink_Options_MobilizeResultsCB:GetChecked()) then config.MobilizeResults = true; else config.MobilizeResults = nil; end
	
	
	if (LootLink_Options_TrackLastSeenCB:GetChecked()) then config.TrackLastSeen = true; else config.TrackLastSeen = nil; end
	
	
	if (LootLink_Options_StoreItemTexturePathCB:GetChecked()) then config.StoreItemTexturePath = true; else config.StoreItemTexturePath = nil; end
	
	
	if (LootLink_Options_EnableToggleButtonCB:GetChecked()) then config.EnableToggleButton = true; else config.EnableToggleButton = nil; end
	
	
	for tooltipName, tooltipSettings in pairs(self.TempTooltipSettings) do
		config.TooltipSettings[tooltipName] = tooltipSettings;
	end
	
	
	if (LootLink_Options_EnableQuickChatlinkCB:GetChecked()) then config.EnableQuickChatlink = true; else config.EnableQuickChatlink = nil; end
	
	if (LootLink_Options_NoQuickChatlinkForSlashCommandsCB:GetChecked()) then config.NoQuickChatlinkForSlashCommands = true; else config.NoQuickChatlinkForSlashCommands = nil; end
	
	if (LootLink_Options_NoSuggestionsForQuickChatlinkCB:GetChecked()) then config.NoSuggestionsForQuickChatlink = true; else config.NoSuggestionsForQuickChatlink = nil; end
	
	
	if (LootLink_Options_EnableSlashLLCB:GetChecked()) then config.EnableSlashLL = true; else config.EnableSlashLL = nil; end
	
	
	if (LootLink_Options_EnableAutoLinkBotCB:GetChecked()) then config.EnableAutoLinkBot = true; else config.EnableAutoLinkBot = nil; end
	
	config.AutoLinkBotMinLength = LootLink_Options_AutoLinkBotMinLengthEB:GetNumber();
	
	config.AutoLinkBotWatchedChannels = {};
	
	for channelName in pairs(self.TempAutoLinkBotWatchedChannels) do
		config.AutoLinkBotWatchedChannels[channelName] = true;
	end
	
	
	if (LootLink_Options_EnableDataSharingCB:GetChecked()) then config.EnableDataSharing = true; else config.EnableDataSharing = nil; end
	
	config.DataSharingBroadcastChannels = {};
	
	for channelName in pairs(self.TempDataSharingBroadcastChannels) do
		config.DataSharingBroadcastChannels[channelName] = true;
	end
	
	
	config.MinStoredRarity = LootLink_Options_MinStoredRarityDD.currID;
	
	config.MinDisplayedRarity = LootLink_Options_MinDisplayedRarityDD.currID;
	
	
	PlaySound("gsTitleOptionOK");
end



LootLink_Options_ApplyButton:SetScript("OnClick", function(self)
	local lootlink = LootLink;
	
	lootlink:Options_SaveValues();
	lootlink:Main_ApplyConfig();
	lootlink:Results_FullRebuild();
end);




function LootLink:Options_TooltipSettingsDD_OnClick()
	local button = this;
	local settings = self.TempTooltipSettings;
	local currentNumbers = settings[button.owner]; -- "owner" is the name of the tooltip, not the tooltip itself.
	
	local stringsub = self.STRING_LIBRARY.sub;
	
	local value = button.value; -- "value" is the index, 1 through 7, to be flipped from 2 to 1 or 1 to 2.
	
	settings[button.owner] = tonumber(
	  stringsub(currentNumbers, 1, value - 1)
	  ..((stringsub(currentNumbers, value, value) == "2" and 1) or 2) -- Equivalent to "if (val == "2") then val = 1; else val = 2; end".
	  ..stringsub(currentNumbers, value + 1)
	);
end



function LootLink:Options_TooltipSettingsDD_Initialize(level)
	if (level == 2) then
		local button = this;
		local parent = button:GetParent();
		
		local tooltipName;
		
		if (parent:GetName() == "DropDownList1") then tooltipName = button.tooltipTitle; else tooltipName = parent.tooltipTitle; end
		
		
		local settings = self.TempTooltipSettings[tooltipName];
		
		local addButton = UIDropDownMenu_AddButton;
		
		local buttonInfo = self:Main_GetReusableTable(1);
		
		buttonInfo.isTitle = true;
		buttonInfo.text = tooltipName;
		buttonInfo.notCheckable = true;
		
		addButton(buttonInfo, 2);
		
		buttonInfo.isTitle = nil;
		buttonInfo.notCheckable = nil;
		buttonInfo.disabled = nil;
		
		buttonInfo.func = self.Options_TooltipSettingsDD_OnClick;
		buttonInfo.arg1 = self;
		buttonInfo.owner = tooltipName;
		buttonInfo.keepShownOnClick = true;
		
		local stringsub = self.STRING_LIBRARY.sub;
		
		local localization = self.LOCALIZATION;
		
		
		for index = 1, self.STRING_LIBRARY.len(settings) do
			buttonInfo.text = localization["OPTIONS_TOOLTIP_SETTINGS_INDEX"..index];
			buttonInfo.value = index;
			buttonInfo.checked = (stringsub(settings, index, index) == "2");
			addButton(buttonInfo, 2);
		end
		
		
	else
		local buttonInfo = self:Main_GetReusableTable(1);
		buttonInfo.notCheckable = true;
		buttonInfo.hasArrow = true;
		
		local addButton = UIDropDownMenu_AddButton;
		
		local optionsTooltips = self.LOCALIZATION.OPTIONS_TOOLTIPS;
		
		
		for tooltipName in pairs(self.TempTooltipSettings) do
			buttonInfo.text = tooltipName;
			
			buttonInfo.tooltipTitle = tooltipName;
			buttonInfo.tooltipText = optionsTooltips[tooltipName];
			
			addButton(buttonInfo);
		end
	end
end


LootLink_Options_TooltipSettingsDD.initialize = (function(level) LootLink:Options_TooltipSettingsDD_Initialize(level); end);




function LootLink:Options_MinRarityDDButton_OnClick()
	local button = this;
	button.owner.currID = button.value;
	
	local text = getglobal(button.owner:GetName().."Text");
	text:SetText(button:GetText());
	text:SetTextColor(button:GetTextColor());
end



function LootLink:Options_MinRarityDD_Initialize()
	local buttonInfo = self:Main_GetReusableTable(1);
	
	buttonInfo.notCheckable = true;
	buttonInfo.func = self.Options_MinRarityDDButton_OnClick;
	buttonInfo.arg1 = self;
	buttonInfo.owner = this:GetParent(); -- Either LootLink_Options_MinStoredRarityDD or LootLink_Options_MinDisplayedRarityDD.
	
	local getglobal = getglobal;
	local addButton = UIDropDownMenu_AddButton;
	
	local rarityList = ITEM_QUALITY_COLORS;
	local currentTable;
	
	for rarityNum = 0, 6 do
		currentTable = rarityList[rarityNum];
		buttonInfo.value = rarityNum;
		buttonInfo.text = getglobal("ITEM_QUALITY"..rarityNum.."_DESC");
		buttonInfo.textR = currentTable.r;
		buttonInfo.textG = currentTable.g;
		buttonInfo.textB = currentTable.b;
		addButton(buttonInfo);
	end
end



LootLink_Options_MinStoredRarityDD.initialize = (function(level) LootLink:Options_MinRarityDD_Initialize(); end);

LootLink_Options_MinDisplayedRarityDD.initialize = (function(level) LootLink:Options_MinRarityDD_Initialize(); end);




function LootLink:Options_ConfirmLightMode()
	local pairs = pairs;
	
	local currentTable;
	
	
	for itemID, itemTable in pairs(self.Database) do
		itemTable[5] = nil;
		
		currentTable = itemTable[3];
		
		if (currentTable) then
			for suffixID, suffixData in pairs(currentTable) do
				if (suffixID < 0) then
					for instanceID, instanceData in pairs(suffixData) do
						suffixData[instanceID] = false;
					end
				else
					currentTable[suffixID] = false;
				end
			end
		end
	end
	
	
	self.Config.LightMode = true;
	
	DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.OPTIONS_LIGHT_MODE_ENABLED, 0.0, 0.8, 0.8);
end



StaticPopupDialogs["LOOTLINK_CONFIRM_LIGHTMODE"] = {
	text = LootLink.LOCALIZATION.OPTIONS_LIGHT_MODE_CONFIRM;
	
	button1 = YES;
	button2 = NO;
	
	timeout = 0;
	whileDead = true;
	showAlert = true;
	
	
	OnAccept = (function() LootLink:Options_ConfirmLightMode(); end);
};




function LootLink:Options_AutoLinkBotWatchedChannelsDDButton_OnClick(channelName)
	local channel = self.LOCALIZATION.OPTIONS_AUTOLINKBOT_WATCHED_CHANNELS_LIST[channelName];
	
	local watched = self.TempAutoLinkBotWatchedChannels;
	
	
	if (watched[channel]) then
		watched[channel] = nil;
	else
		watched[channel] = true;
	end
end



function LootLink:Options_AutoLinkBotWatchedChannelsDD_Initialize()
	local tableinsert = self.TABLE_LIBRARY.insert;
	
	local watchedList = self.LOCALIZATION.OPTIONS_AUTOLINKBOT_WATCHED_CHANNELS_LIST;
	local sortingTable = self:Main_GetReusableTable(1);
	
	for channelName in pairs(watchedList) do
		tableinsert(sortingTable, channelName);
	end
	
	self.TABLE_LIBRARY.sort(sortingTable);
	
	
	local addButton = UIDropDownMenu_AddButton;
	
	local tempWatched = self.TempAutoLinkBotWatchedChannels;
	local buttonInfo = self:Main_GetReusableTable(2);
	
	buttonInfo.func = self.Options_AutoLinkBotWatchedChannelsDDButton_OnClick;
	buttonInfo.arg1 = self;
	buttonInfo.keepShownOnClick = true;
	
	for index, channelName in ipairs(sortingTable) do
		buttonInfo.text = channelName;
		buttonInfo.arg2 = channelName;
		buttonInfo.checked = tempWatched[watchedList[channelName]];
		addButton(buttonInfo);
	end
end


LootLink_Options_AutoLinkBotWatchedChannelsDD.initialize = (function() LootLink:Options_AutoLinkBotWatchedChannelsDD_Initialize(); end);




function LootLink:Options_DataSharingBroadcastChannelsDDButton_OnClick(channelName)
	local channel = self.LOCALIZATION.OPTIONS_DATASHARING_BROADCAST_CHANNELS_LIST[channelName];
	
	local broadcastChannels = self.TempDataSharingBroadcastChannels;
	
	
	if (broadcastChannels[channel]) then
		broadcastChannels[channel] = nil;
	else
		broadcastChannels[channel] = true;
	end
end



function LootLink:Options_DataSharingBroadcastChannelsDD_Initialize()
	local tableinsert = self.TABLE_LIBRARY.insert;
	
	local channelsList = self.LOCALIZATION.OPTIONS_DATASHARING_BROADCAST_CHANNELS_LIST;
	local sortingTable = self:Main_GetReusableTable(1);
	
	for channelName in pairs(channelsList) do
		tableinsert(sortingTable, channelName);
	end
	
	self.TABLE_LIBRARY.sort(sortingTable);
	
	
	local addButton = UIDropDownMenu_AddButton;
	
	local tempChannels = self.TempDataSharingBroadcastChannels;
	local buttonInfo = self:Main_GetReusableTable(2);
	
	buttonInfo.func = self.Options_DataSharingBroadcastChannelsDDButton_OnClick;
	buttonInfo.arg1 = self;
	buttonInfo.keepShownOnClick = true;
	
	for index, channelName in ipairs(sortingTable) do
		buttonInfo.text = channelName;
		buttonInfo.arg2 = channelName;
		buttonInfo.checked = tempChannels[channelsList[channelName]];
		addButton(buttonInfo);
	end
end


LootLink_Options_DataSharingBroadcastChannelsDD.initialize = (function() LootLink:Options_DataSharingBroadcastChannelsDD_Initialize(); end);




function LootLink:Options_ListAllTrustedPlayers()
	local tableinsert = self.TABLE_LIBRARY.insert;
	
	local trusted = self.TrustedDataSendersForCurrentRealm;
	
	if (not trusted) then
		trusted = {};
		self.Config.TrustedDataSenders[GetRealmName()] = trusted;
		self.TrustedDataSendersForCurrentRealm = trusted;
	end
	
	local sortingTable = self:Main_GetReusableTable(1);
	
	
	for name in pairs(trusted) do
		tableinsert(sortingTable, name);
	end
	
	self.TABLE_LIBRARY.sort(sortingTable);
	
	
	DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.OPTIONS_TRUSTED_PLAYERS_LIST:format(self.TABLE_LIBRARY.concat(sortingTable, ", ")), 0.0, 0.8, 0.8);
end



function LootLink:Options_ToggleTrustedStatusForPlayer(name)
	local trusted = self.TrustedDataSendersForCurrentRealm;
	
	if (not trusted) then
		trusted = {};
		self.Config.TrustedDataSenders[GetRealmName()] = trusted;
		self.TrustedDataSendersForCurrentRealm = trusted;
	end
	
	local loweredName = name:lower();
	
	local isTrusted;
	
	
	if (trusted[loweredName]) then
		trusted[loweredName] = nil;
		isTrusted = false;
	else
		trusted[loweredName] = true;
		isTrusted = true;
	end
	
	
	DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.OPTIONS_PLAYER_TRUST_TOGGLED:format(name, tostring(isTrusted)), 0.0, 0.8, 0.8);
	
	return isTrusted;
end



StaticPopupDialogs["LOOTLINK_MODIFY_TRUSTED_PLAYERS"] = {
	text = LootLink.LOCALIZATION.OPTIONS_MODIFY_TRUSTED_PLAYERS_TITLE;
	
	button1 = LootLink.LOCALIZATION.OPTIONS_GENERIC_TOGGLE;
	button2 = CLOSE;
	
	hasEditBox = true;
	maxLetters = 24;
	
	timeout = 0;
	whileDead = true;
	hideOnEscape = true;
	
	
	OnShow = (function() LootLink.GLOBAL_ENVIRONMENT[this:GetName().."EditBox"]:SetFocus(); end);
	
	
	OnHide = (function() LootLink.GLOBAL_ENVIRONMENT[this:GetName().."EditBox"]:SetText(""); end);
	
	
	OnAccept = (function()
		local editBox = LootLink.GLOBAL_ENVIRONMENT[this:GetParent():GetName().."EditBox"];
		
		LootLink:Options_ToggleTrustedStatusForPlayer(editBox:GetText());
		editBox:SetText("");
		
		return true; -- Returning true keeps the dialog shown.
	end);
	
	
	EditBoxOnEnterPressed = (function()
		local editBox = this;
		
		LootLink:Options_ToggleTrustedStatusForPlayer(editBox:GetText());
		editBox:SetText("");
	end);
};



LootLink_Options_ModifyTrustedPlayersButton:SetScript("OnClick", (function() StaticPopup_Show("LOOTLINK_MODIFY_TRUSTED_PLAYERS"); end));


LootLink_Options_ListTrustedPlayersButton:SetScript("OnClick", (function() LootLink:Options_ListAllTrustedPlayers(); end));




end

