

if (LootLink.Options_InitializeLocalization) then return; end




-- This localization file is the fallback in case no others load, so the following line should remain commented out.

--if (GetLocale() ~= "enUS") then return; end




function LootLink:Options_InitializeLocalization()




LootLink_Options_HeaderText:SetText("LootLink "..GetAddOnMetadata("LootLink", "Version").." - Options");


LootLink_Options_LightModeCBText:SetText("Enable Light Mode");

LootLink_Options_EnableQuickSearchCBText:SetText("Enable QuickSearch");
LootLink_Options_AutoFocusQuickSearchCBText:SetText("Auto focus on QuickSearch");

LootLink_Options_MobilizeResultsCBText:SetText("Mobilize results window");

LootLink_Options_TrackLastSeenCBText:SetText("Enable time tracking");

LootLink_Options_StoreItemTexturePathCBText:SetText("Store item texture paths");

LootLink_Options_EnableToggleButtonCBText:SetText("Enable toggle button");


LootLink_Options_TooltipSettingsDDText:SetText("Tooltip Settings");

LootLink_Options_EnableQuickChatlinkCBText:SetText("Enable QuickChatlink");
LootLink_Options_NoQuickChatlinkForSlashCommandsCBText:SetText("Except slash commands");
LootLink_Options_NoSuggestionsForQuickChatlinkCBText:SetText("Disable suggestions");

LootLink_Options_EnableSlashLLCBText:SetText("Enable \"/ll\" command");

LootLink_Options_EnableAutoLinkBotCBText:SetText("Enable AutoLinkBot");
LootLink_Options_AutoLinkBotMinLengthEBLabel:SetText("Min. search length:");
LootLink_Options_AutoLinkBotWatchedChannelsDDText:SetText("Watched Channels");

LootLink_Options_EnableDataSharingCBText:SetText("Enable data sharing");
LootLink_Options_ListTrustedPlayersButtonText:SetText("List trusted");
LootLink_Options_ModifyTrustedPlayersButtonText:SetText("Modify trusted");
LootLink_Options_DataSharingBroadcastChannelsDDText:SetText("Broadcast Channels");


LootLink_Options_MinStoredRarityDDLabel:SetText("Min. Stored Rarity");
LootLink_Options_MinDisplayedRarityDDLabel:SetText("Min. Displayed Rarity");


LootLink_Options_FullReparseButton:SetText("Reparse");

LootLink_Options_AuctionScanButton:SetText("Scan");


LootLink_Options_ApplyButton:SetText("Apply");




local localization = self.LOCALIZATION;



localization.OPTIONS_GENERIC_TOGGLE = ("Toggle");



localization.OPTIONS_AUTOLINKBOT_WATCHED_CHANNELS_LIST = {
	["Say"] = ("SAY");
	["Yell"] = ("YELL");
	["Whisper"] = ("WHISPER");
	["Guild"] = ("GUILD");
	["Officer"] = ("OFFICER");
	["Party"] = ("PARTY");
	["Raid"] = ("RAID");
	["Battleground"] = ("BATTLEGROUND");
};



localization.OPTIONS_DATASHARING_BROADCAST_CHANNELS_LIST = {
	["Guild addon channel"] = ("GUILD");
	["Party addon channel"] = ("PARTY");
	["Raid addon channel"] = ("RAID");
	["Battleground addon channel"] = ("BATTLEGROUND");
	["Global hidden chat channel"] = ("CHANNEL");
};



localization.OPTIONS_TOOLTIPS = {
	LootLink_Options_LightModeCB = ("Check to enable Light Mode, wherein less memory is needed but full-text searches are unavailable. On average, removing full-text data will save you roughly 0.12 kilobytes of memory per item in your database.");
	
	
	LootLink_Options_EnableQuickSearchCB = ("Check to enable the QuickSearch box at the bottom of the results window. The box allows you to search through the current results (press Tab) or create a fresh set of results by name (press Enter).\n\nNote that if this is enabled, the 23rd item slot in the results list will be hidden to make room for the edit box, thus limiting the list to displaying only 22 items per scroll page at a time.");
	
	LootLink_Options_AutoFocusQuickSearchCB = ("Check to have your cursor's focus automatically set to the QuickSearch box (if QuickSearch is enabled) whenever you open the LootLink window.");
	
	
	LootLink_Options_MobilizeResultsCB = ("Check to allow the results window to be dragged with the mouse to a position on the screen of your choosing, much like how the search and options windows can be relocated.\n\nIf unchecked, the results frame's position will be controlled by the default UI, which will move it relative to other windows like the character frame and the mail frame.");
	
	
	LootLink_Options_TrackLastSeenCB = ("Check to enable tracking of the last time each item was seen. The time is set any time the item's link appears in chat or the item is parsed within your bags/inventory. This barely requires any memory, but should be disabled if you are not using the timestamps.\n\nIf disabled, the \"Time item was last seen\" tooltip option will not be able to function.");
	
	
	LootLink_Options_StoreItemTexturePathCB = ("Check to store item texture paths for all items in your database. This will allow you to view their icons even while they are not in your local cache, but it requires a large amount of memory.");
	
	
	LootLink_Options_EnableToggleButtonCB = ("Check to enable a tiny, mobile minimap-style button which, when clicked, toggles the results window.\n\nIts text color will turn yellow when a new item is added to your database, just like the results window's title text does.");
	
	
	LootLink_Options_MinStoredRarityDD = ("This dropdown menu sets the minimum rarity that an item must meet to be stored in your database. The default is \"Poor\", which means all items are stored.");
	
	LootLink_Options_MinDisplayedRarityDD = ("This dropdown menu sets the minimu rarity that an item must meet to be displayed in any search results. The item will still exist in your database, can be used in QuickChatlink, and will have its vendor price stored, but it will not be displayed when searching. The default is \"Poor\", which means all items are shown in the results.");
	
	
	
	LootLink_Options_TooltipSettingsDD = ("This dropdown menu controls which pieces of extra information are displayed in a given tooltip. The extra information available includes: how much a vendor would buy it for; the internal level of the item, as the game sees it; the internal basic IDs (item ID, enchant ID, suffix ID, and instance ID); the internal socket IDs (gem slot 1 ID, gem slot 2 ID, gem slot 3 ID, and the gem socket bonus ID); the time (including date) when the item was last seen; whether or not to include a separator line between this information and the normal tooltip; whether to display this extra information in the default LootLink teal color, or just plain white instead; and the maximum number of the item which can be in a single stack.");
	
	GameTooltip = ("This tooltip is the one used by the vast majority of the default UI, and appears for the mouseover display of all default item slots.");
	ItemRefTooltip = ("This tooltip appears whenever you click an item link in chat.");
	LootLink_ResultsTooltip = ("This tooltip appears when mousing over item slots in the LootLink results window's list of items.");
	AtlasLootTooltip = ("This tooltip appears when mousing over item icons in AtlasLoot Enhanced.");
	
	
	LootLink_Options_EnableQuickChatlinkCB = ("Check to enable automatic replacement of link item text in the chat edit box with the real, clickable link from your database.\n\nIf enabled, simply type the item's name (in brackets and with the correct spelling, optionally adding the level of the item at the end in curly braces, such as... \n\n[scout's blade {48}]\n\n ...for the level 48 version of the Warsong Gulch weapon) and the real link will appear.");
	
	LootLink_Options_NoQuickChatlinkForSlashCommandsCB = ("Check to refrain from attempting to replace bracketed text when the first character in the edit box is a forward slash (\"/\").");
	
	LootLink_Options_NoSuggestionsForQuickChatlinkCB = ("Check to refrain from displaying any suggested completions for the link you are currently typing. This includes both the highlighted text in the chat edit box itself, as well as the teal button to the right of the edit box which opens a dropdown menu.\n\nIf enabled, you can simply press Tab while typing the link to fill in the rest of the matching text and the real link, or Shift-Tab to switch between potential auto-completions.");
	
	
	LootLink_Options_EnableSlashLLCB = ("Check to enable the shortened version of the \"/lootlink\" slash command, which is two lower-case Ls. You should uncheck this if you find that some other addon needs to use that particular abbreviation for its slash commands.\n\nNote that the longer version of the slash command will always be present and functional.");
	
	
	LootLink_Options_EnableAutoLinkBotCB = ("Check to enable the AutoLinkBot, which automatically replies to messages of the format \"!item [text]\" with whispers to the person who sent the message, containing links for up to 9 items in your database which had [text] in their name; or of the format \">item [text]\" with a link to a single matching item, sent to the chat channel from which the request was placed.");
	
	LootLink_Options_AutoLinkBotMinLengthEB = ("Enter the minimum number of characters that users of the AutoLinkBot must type for their search request to be attempted. Defaults to 4 characters.");
	
	LootLink_Options_AutoLinkBotWatchedChannelsDD = ("This dropdown menu sets which channels the AutoLinkBot will monitor for incoming link requests.");
	
	
	LootLink_Options_EnableDataSharingCB = ("Check to automatically share your item data with other users of the addon via a hidden chat channel (\"lootlinkdatasharing\") and the built-in addon communication channels, and receive similar data back from them in return.");
	
	LootLink_Options_ListTrustedPlayersButton = ("Click to alphabetically list every player on your trusted list for this server.\n\nYou will be able to receive new items in your database via the data sharing channel from these trusted players. The data of non-trusted players will only fill in missing fields of existing items, never create new items or overwrite your existing data. This is to prevent link spoofing.");
	
	LootLink_Options_ModifyTrustedPlayersButton = ("Click to show a popup dialog with a text edit box. Type the name of the player whose trusted status you wish to modify, then press Enter or click the Toggle button to perform that action. Click the Close button, or press Escape, to finish.\n\nYou will be able to receive new items in your database via the data sharing channel from these trusted players. The data of non-trusted players will only fill in missing fields of existing items, never create new items or overwrite your existing data. This is to prevent link spoofing.");
	
	LootLink_Options_DataSharingBroadcastChannelsDD = ("This dropdown menu sets which channels will be used to broadcast and receive data. Be warned, however, that selecting more than two channels may result in frequent disconnects from the server, due to too much data being sent at once.");
	
	
	
	LootLink_Options_FullReparseButton = ("Triggers a full scan of your own database, parsing all items and adding or ensuring search data for each. This operation also corrects any items with incorrect names.\n\nThese tasks may take up to thirty seconds to complete, depending on the size of your database and the speed of your processor. During this time the screen may appear to be frozen, but it is just occupied, so you should allow it to finish.");
	
	LootLink_Options_AuctionScanButton = ("Click to schedule an automatic scan of every page of the auction house upon your next visit to one. The scan can be cancelled by simply closing the auction window.");
	
	
	
	LootLink_Options_ApplyButton = ("Click to save and apply the currently specified settings.");
	
	LootLink_Options_CloseButton = ("Click to close this window, discarding any changes you made to the settings since the last time you clicked the \"Apply\" button.");
};



localization.OPTIONS_TOOLTIP_SETTINGS_INDEX1 = ("Vendor value of item");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX2 = ("Item's internal level");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX3 = ("Item's basic IDs");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX4 = ("Item's socket IDs");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX5 = ("Time item was last seen");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX6 = ("Separator line");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX7 = ("White text instead of teal");
localization.OPTIONS_TOOLTIP_SETTINGS_INDEX8 = ("Number of items per stack");



localization.OPTIONS_TRUSTED_PLAYERS_LIST = ("LootLink: All players on your list of trusted data sharers for this server: %s");

localization.OPTIONS_MODIFY_TRUSTED_PLAYERS_TITLE = ("Enter the name of the player for whom you wish to toggle trusted status, then press Enter or click the Toggle button.");

localization.OPTIONS_PLAYER_TRUST_TOGGLED = ("LootLink: Data sharing trusted status for the player named \"%s\" on this server is now set to %s.");



localization.OPTIONS_LIGHT_MODE_CONFIRM = ("Really enable Light Mode?\nThis will remove all full-text data and is therefore irreversible.");
localization.OPTIONS_LIGHT_MODE_ENABLED = ("LootLink: Light Mode enabled. Purging all full-text information from database.");
localization.OPTIONS_LIGHT_MODE_DISABLED = ("LootLink: Light Mode disabled, allowing full-text searches but consuming more memory. It is recommended that you type \"/lootlink reparse\" to populate the items in your database with full-text data.");




end

