

function LootLink:Options_InitializeXML()




local LootLink = self;


local createFrame = CreateFrame;
local uiDropDownMenu_SetWidth = UIDropDownMenu_SetWidth;


local function showHelp(button) LootLink:Options_ShowHelpTooltipForElement(button); end

local function hideHelp(button) GameTooltip:Hide(); end



local displayFrame = createFrame("Frame", "LootLink_Options_DisplayFrame", UIParent);

displayFrame.LOOTLINK = self;
self.OPTIONS_DISPLAY_FRAME = displayFrame;

displayFrame:Hide();
displayFrame:EnableMouse(true);
displayFrame:SetMovable(true);
displayFrame:SetToplevel(true);
displayFrame:SetClampedToScreen(true);

displayFrame:SetWidth(390);
displayFrame:SetHeight(535);
displayFrame:SetPoint("CENTER", UIParent, "CENTER", 50, 50);

displayFrame:SetScript("OnMouseDown", (function(self, button) self:StartMoving(); end));
displayFrame:SetScript("OnMouseUp", (function(self, button) self:StopMovingOrSizing(); end));



local backdropTable = self:Main_GetReusableTable(1);
backdropTable.bgFile = ("Interface\\DialogFrame\\UI-DialogBox-Background");
backdropTable.edgeFile = ("Interface\\DialogFrame\\UI-DialogBox-Border");
backdropTable.tile = true;
backdropTable.tileSize = 32;
backdropTable.edgeSize = 32;

local insetsTable = self:Main_GetReusableTable(2);
insetsTable.left = 11;
insetsTable.right = 12;
insetsTable.top = 12;
insetsTable.bottom = 11;
backdropTable.insets = insetsTable;

displayFrame:SetBackdrop(backdropTable);



local headerTexture = displayFrame:CreateTexture(nil, "ARTWORK");

headerTexture:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header");

headerTexture:SetWidth(350);
headerTexture:SetHeight(64);
headerTexture:SetPoint("TOP", displayFrame, "TOP", 0, 12);


local headerText = displayFrame:CreateFontString("LootLink_Options_HeaderText", "ARTWORK", "GameFontNormal");

headerText:SetPoint("TOP", displayFrame, "TOP", 0, -2);


local emailWebsiteText = displayFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");

emailWebsiteText:SetText("saeris.sanoora@gmail.com ||  http://tinyurl.com/o7ef4");

emailWebsiteText:SetTextColor(1.0, 1.0, 1.0);
emailWebsiteText:SetPoint("BOTTOM", displayFrame, "BOTTOM", 0, 45);



local fullReparseButton = createFrame("Button", "LootLink_Options_FullReparseButton", displayFrame, "GameMenuButtonTemplate");

fullReparseButton:SetWidth(80);
fullReparseButton:SetHeight(21);
fullReparseButton:SetPoint("BOTTOMLEFT", displayFrame, "BOTTOMLEFT", 16, 16);

fullReparseButton:SetScript("OnEnter", showHelp);
fullReparseButton:SetScript("OnLeave", hideHelp);

fullReparseButton:SetScript("OnClick", (function(self, clickType) LootLink:Main_SlashCommandHandler(LootLink.LOCALIZATION.SLASH_FULLREPARSE); end));



local auctionScanButton = createFrame("Button", "LootLink_Options_AuctionScanButton", displayFrame, "GameMenuButtonTemplate");

auctionScanButton:SetWidth(80);
auctionScanButton:SetHeight(21);
auctionScanButton:SetPoint("LEFT", fullReparseButton, "RIGHT", 0, 0);

auctionScanButton:SetScript("OnEnter", showHelp);
auctionScanButton:SetScript("OnLeave", hideHelp);

auctionScanButton:SetScript("OnClick", (function(self, clickType) LootLink:Main_SlashCommandHandler(LootLink.LOCALIZATION.SLASH_AUCTIONSCAN); end));



local closeButton = createFrame("Button", "LootLink_Options_CloseButton", displayFrame, "GameMenuButtonTemplate");

closeButton:SetText(CLOSE);

closeButton:SetWidth(80);
closeButton:SetHeight(21);
closeButton:SetPoint("BOTTOMRIGHT", displayFrame, "BOTTOMRIGHT", -16, 16);

closeButton:SetScript("OnEnter", showHelp);
closeButton:SetScript("OnLeave", hideHelp);

closeButton:SetScript("OnClick",
  function(self, clickType)
	PlaySound("gsTitleOptionExit");
	LootLink.OPTIONS_DISPLAY_FRAME:Hide();
  end
);



local applyButton = createFrame("Button", "LootLink_Options_ApplyButton", displayFrame, "GameMenuButtonTemplate");

applyButton:SetWidth(80);
applyButton:SetHeight(21);
applyButton:SetPoint("RIGHT", closeButton, "LEFT", 0, 0);

applyButton:SetScript("OnEnter", showHelp);
applyButton:SetScript("OnLeave", hideHelp);



local lightModeCB = createFrame("CheckButton", "LootLink_Options_LightModeCB", displayFrame, "OptionsCheckButtonTemplate");

lightModeCB:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", 20, -45);

lightModeCB:SetScript("OnEnter", showHelp);
lightModeCB:SetScript("OnLeave", hideHelp);



local enableQuickSearchCB = createFrame("CheckButton", "LootLink_Options_EnableQuickSearchCB", displayFrame, "OptionsCheckButtonTemplate");

enableQuickSearchCB:SetPoint("TOPLEFT", lightModeCB, "BOTTOMLEFT", 0, -15);

enableQuickSearchCB:SetScript("OnEnter", showHelp);
enableQuickSearchCB:SetScript("OnLeave", hideHelp);


local autoFocusQuickSearchCB = createFrame("CheckButton", "LootLink_Options_AutoFocusQuickSearchCB", displayFrame, "OptionsCheckButtonTemplate");

autoFocusQuickSearchCB:SetWidth(24);
autoFocusQuickSearchCB:SetHeight(24);
autoFocusQuickSearchCB:SetPoint("TOPLEFT", enableQuickSearchCB, "BOTTOMLEFT", 10, 0);

autoFocusQuickSearchCB:SetScript("OnEnter", showHelp);
autoFocusQuickSearchCB:SetScript("OnLeave", hideHelp);



local mobilizeResultsCB = createFrame("CheckButton", "LootLink_Options_MobilizeResultsCB", displayFrame, "OptionsCheckButtonTemplate");

mobilizeResultsCB:SetPoint("TOPLEFT", enableQuickSearchCB, "BOTTOMLEFT", 0, -40);

mobilizeResultsCB:SetScript("OnEnter", showHelp);
mobilizeResultsCB:SetScript("OnLeave", hideHelp);



local trackLastSeenCB = createFrame("CheckButton", "LootLink_Options_TrackLastSeenCB", displayFrame, "OptionsCheckButtonTemplate");

trackLastSeenCB:SetPoint("TOPLEFT", mobilizeResultsCB, "BOTTOMLEFT", 0, -15);

trackLastSeenCB:SetScript("OnEnter", showHelp);
trackLastSeenCB:SetScript("OnLeave", hideHelp);



local storeItemTexturePathCB = createFrame("CheckButton", "LootLink_Options_StoreItemTexturePathCB", displayFrame, "OptionsCheckButtonTemplate");

storeItemTexturePathCB:SetPoint("TOPLEFT", trackLastSeenCB, "BOTTOMLEFT", 0, -15);

storeItemTexturePathCB:SetScript("OnEnter", showHelp);
storeItemTexturePathCB:SetScript("OnLeave", hideHelp);



local enableToggleButtonCB = createFrame("CheckButton", "LootLink_Options_EnableToggleButtonCB", displayFrame, "OptionsCheckButtonTemplate");

enableToggleButtonCB:SetPoint("TOPLEFT", storeItemTexturePathCB, "BOTTOMLEFT", 0, -15);

enableToggleButtonCB:SetScript("OnEnter", showHelp);
enableToggleButtonCB:SetScript("OnLeave", hideHelp);



local minStoredRarityDD = createFrame("Frame", "LootLink_Options_MinStoredRarityDD", displayFrame, "UIDropDownMenuTemplate");

minStoredRarityDD:EnableMouse(true);

minStoredRarityDD:SetPoint("TOPLEFT", enableToggleButtonCB, "BOTTOMLEFT", 0, -35);

minStoredRarityDD:SetScript("OnEnter", showHelp);
minStoredRarityDD:SetScript("OnLeave", hideHelp);

uiDropDownMenu_SetWidth(90, minStoredRarityDD);


local minStoredRarityDDLabel = minStoredRarityDD:CreateFontString("LootLink_Options_MinStoredRarityDDLabel", "OVERLAY", "GameFontNormal");

minStoredRarityDDLabel:SetJustifyH("CENTER");

minStoredRarityDDLabel:SetPoint("TOP", minStoredRarityDD, "TOP", 0, 15);



local minDisplayedRarityDD = createFrame("Frame", "LootLink_Options_MinDisplayedRarityDD", displayFrame, "UIDropDownMenuTemplate");

minDisplayedRarityDD:EnableMouse(true);

minDisplayedRarityDD:SetPoint("TOPLEFT", minStoredRarityDD, "BOTTOMLEFT", 0, -20);

minDisplayedRarityDD:SetScript("OnEnter", showHelp);
minDisplayedRarityDD:SetScript("OnLeave", hideHelp);

uiDropDownMenu_SetWidth(90, minDisplayedRarityDD);


local minDisplayedRarityDDLabel = minDisplayedRarityDD:CreateFontString("LootLink_Options_MinDisplayedRarityDDLabel", "OVERLAY", "GameFontNormal");

minDisplayedRarityDDLabel:SetJustifyH("CENTER");

minDisplayedRarityDDLabel:SetPoint("TOP", minDisplayedRarityDD, "TOP", 0, 15);



local tooltipSettingsDD = createFrame("Frame", "LootLink_Options_TooltipSettingsDD", displayFrame, "UIDropDownMenuTemplate");

tooltipSettingsDD:EnableMouse(true);

tooltipSettingsDD:SetPoint("TOPRIGHT", displayFrame, "TOPRIGHT", -18, -47);

tooltipSettingsDD:SetScript("OnEnter", showHelp);
tooltipSettingsDD:SetScript("OnLeave", hideHelp);

uiDropDownMenu_SetWidth(120, tooltipSettingsDD);



local enableQuickChatlinkCB = createFrame("CheckButton", "LootLink_Options_EnableQuickChatlinkCB", displayFrame, "OptionsCheckButtonTemplate");

enableQuickChatlinkCB:SetPoint("TOPLEFT", tooltipSettingsDD, "BOTTOMLEFT", 10, -14);

enableQuickChatlinkCB:SetScript("OnEnter", showHelp);
enableQuickChatlinkCB:SetScript("OnLeave", hideHelp);


local noQuickChatlinkForSlashCommandsCB = createFrame("CheckButton", "LootLink_Options_NoQuickChatlinkForSlashCommandsCB", displayFrame, "OptionsCheckButtonTemplate");

noQuickChatlinkForSlashCommandsCB:SetWidth(24);
noQuickChatlinkForSlashCommandsCB:SetHeight(24);
noQuickChatlinkForSlashCommandsCB:SetPoint("TOPLEFT", enableQuickChatlinkCB, "BOTTOMLEFT", 10, 0);

noQuickChatlinkForSlashCommandsCB:SetScript("OnEnter", showHelp);
noQuickChatlinkForSlashCommandsCB:SetScript("OnLeave", hideHelp);


local noSuggestionsForQuickChatlinkCB = createFrame("CheckButton", "LootLink_Options_NoSuggestionsForQuickChatlinkCB", displayFrame, "OptionsCheckButtonTemplate");

noSuggestionsForQuickChatlinkCB:SetWidth(24);
noSuggestionsForQuickChatlinkCB:SetHeight(24);
noSuggestionsForQuickChatlinkCB:SetPoint("TOPLEFT", noQuickChatlinkForSlashCommandsCB, "BOTTOMLEFT", 0, 0);

noSuggestionsForQuickChatlinkCB:SetScript("OnEnter", showHelp);
noSuggestionsForQuickChatlinkCB:SetScript("OnLeave", hideHelp);



local enableSlashLLCB = createFrame("CheckButton", "LootLink_Options_EnableSlashLLCB", displayFrame, "OptionsCheckButtonTemplate");

enableSlashLLCB:SetPoint("TOPLEFT", enableQuickChatlinkCB, "BOTTOMLEFT", 0, -60);

enableSlashLLCB:SetScript("OnEnter", showHelp);
enableSlashLLCB:SetScript("OnLeave", hideHelp);



local enableAutoLinkBotCB = createFrame("CheckButton", "LootLink_Options_EnableAutoLinkBotCB", displayFrame, "OptionsCheckButtonTemplate");

enableAutoLinkBotCB:SetPoint("TOPLEFT", enableSlashLLCB, "BOTTOMLEFT", 0, -15);

enableAutoLinkBotCB:SetScript("OnEnter", showHelp);
enableAutoLinkBotCB:SetScript("OnLeave", hideHelp);


local autoLinkBotMinLengthEB = createFrame("EditBox", "LootLink_Options_AutoLinkBotMinLengthEB", displayFrame, "InputBoxTemplate");

autoLinkBotMinLengthEB:SetAutoFocus(false);
autoLinkBotMinLengthEB:SetNumeric(true);
autoLinkBotMinLengthEB:SetMaxLetters(1);

autoLinkBotMinLengthEB:SetWidth(20);
autoLinkBotMinLengthEB:SetHeight(20);
autoLinkBotMinLengthEB:SetPoint("TOPLEFT", enableAutoLinkBotCB, "BOTTOMLEFT", 119, 0);

autoLinkBotMinLengthEB:SetScript("OnEnter", showHelp);
autoLinkBotMinLengthEB:SetScript("OnLeave", hideHelp);


local autoLinkBotMinLengthEBLabel = autoLinkBotMinLengthEB:CreateFontString("LootLink_Options_AutoLinkBotMinLengthEBLabel", "OVERLAY", "GameFontNormalSmall");

autoLinkBotMinLengthEBLabel:SetJustifyH("RIGHT");

autoLinkBotMinLengthEBLabel:SetPoint("RIGHT", autoLinkBotMinLengthEB, "LEFT", -10, 0);


local autoLinkBotWatchedChannelsDD = createFrame("Frame", "LootLink_Options_AutoLinkBotWatchedChannelsDD", displayFrame, "UIDropDownMenuTemplate");

autoLinkBotWatchedChannelsDD:EnableMouse(true);

autoLinkBotWatchedChannelsDD:SetPoint("TOPLEFT", autoLinkBotMinLengthEB, "BOTTOMLEFT", -125, -8);

autoLinkBotWatchedChannelsDD:SetScript("OnEnter", showHelp);
autoLinkBotWatchedChannelsDD:SetScript("OnLeave", hideHelp);

uiDropDownMenu_SetWidth(120, autoLinkBotWatchedChannelsDD);



local enableDataSharingCB = createFrame("CheckButton", "LootLink_Options_EnableDataSharingCB", displayFrame, "OptionsCheckButtonTemplate");

enableDataSharingCB:SetPoint("TOPLEFT", enableAutoLinkBotCB, "BOTTOMLEFT", 0, -75);

enableDataSharingCB:SetScript("OnEnter", showHelp);
enableDataSharingCB:SetScript("OnLeave", hideHelp);


local listTrustedPlayersButton = createFrame("Button", "LootLink_Options_ListTrustedPlayersButton", displayFrame, "GameMenuButtonTemplate");

listTrustedPlayersButton:SetWidth(130);
listTrustedPlayersButton:SetHeight(20);
listTrustedPlayersButton:SetPoint("TOPLEFT", enableDataSharingCB, "BOTTOMLEFT", 15, 0);

listTrustedPlayersButton:SetScript("OnEnter", showHelp);
listTrustedPlayersButton:SetScript("OnLeave", hideHelp);


local modifyTrustedPlayersButton = createFrame("Button", "LootLink_Options_ModifyTrustedPlayersButton", displayFrame, "GameMenuButtonTemplate");

modifyTrustedPlayersButton:SetWidth(130);
modifyTrustedPlayersButton:SetHeight(20);
modifyTrustedPlayersButton:SetPoint("TOPLEFT", listTrustedPlayersButton, "BOTTOMLEFT", 0, -5);

modifyTrustedPlayersButton:SetScript("OnEnter", showHelp);
modifyTrustedPlayersButton:SetScript("OnLeave", hideHelp);


local dataSharingBroadcastChannelsDD = createFrame("Frame", "LootLink_Options_DataSharingBroadcastChannelsDD", displayFrame, "UIDropDownMenuTemplate");

dataSharingBroadcastChannelsDD:EnableMouse(true);

dataSharingBroadcastChannelsDD:SetPoint("TOPLEFT", modifyTrustedPlayersButton, "BOTTOMLEFT", -25, -10);

dataSharingBroadcastChannelsDD:SetScript("OnEnter", showHelp);
dataSharingBroadcastChannelsDD:SetScript("OnLeave", hideHelp);

uiDropDownMenu_SetWidth(130, dataSharingBroadcastChannelsDD);




end

