

function LootLink:QuickChatlink_Initialize()


self:QuickChatlink_InitializeXML();

self.QuickChatlink_InitializeXML = nil;


self:QuickChatlink_InitializeLocalization();

self.QuickChatlink_InitializeLocalization = nil;




local LootLink = self;




LootLink.QuickChatlinkExcludedItems = {};


LootLink.QuickChatlinkIncludedItems = {};


LootLink.QuickChatlinkTextMemory = ("");



LootLink.Original_ChatEdit_CustomTabPressed = ChatEdit_CustomTabPressed;


LootLink.Original_ChatFrameEditBox_OnChar = ChatFrameEditBox:GetScript("OnChar");



do
	local dropdown = LootLink.QUICKCHATLINK_SUGGESTIONS_DD;
	
	dropdown.point = ("BOTTOMLEFT");
	dropdown.relativeTo = LootLink.QUICKCHATLINK_SUGGESTIONS_BUTTON;
	dropdown.relativePoint = ("TOPRIGHT");
	dropdown.yOffset = 200;
	dropdown.xOffset = 0;
	
	dropdown.displayMode = ("MENU");
end




local function LootLink_QuickChatlink_GetLinkForText(leadingChars, text, followingChars)
	if (leadingChars == "|h" or followingChars == "|h" or tonumber(text)) then
		-- Don't bother with the rest, since this is either already a real link or just a bunch of numbers, and no item has JUST numbers for its name.
		return nil;
	end
	
	
	local itemTable, suffixID;
	local startLoc, endLoc, level = text:find("%s+{(%d+)}$");
	
	if (level) then
		itemTable, suffixID = LootLink:Matching_GetItemTableAndSuffixIDByName(
		  (LootLink:Matching_ByLevel(LootLink:Main_GetReusableTable(1), true, nil, level)),
		  text:sub(1, (startLoc - 1))
		);
	else
		itemTable, suffixID = LootLink:Matching_GetItemTableAndSuffixIDByName(LootLink.Database, text);
	end
	
	return (itemTable and LootLink:Matching_GetHyperlinkByItemTableAndSuffixID(itemTable, suffixID));
end




function LootLink:QuickChatlink_InsertSuggestedItem(itemTable, suffixID, editBox)
	if (not itemTable) then return; end
	
	if (not editBox) then editBox = ChatFrameEditBox; end
	
	
	local text = editBox:GetText();
	local startLoc = text:match("^.*()%[.+$");
	
	if (startLoc) then
		editBox:SetText(text:sub(1, (startLoc - 1))..self:Matching_GetHyperlinkByItemTableAndSuffixID(itemTable, suffixID));
	end
	
	
	self.QuickChatlinkSuggestedItemTable = nil;
	self.QuickChatlinkSuggestedSuffixID = nil;
	self.QUICKCHATLINK_SUGGESTIONS_BUTTON:Hide();
end




function LootLink:QuickChatlink_BuildSuggestions(text)
	local textMemory = self.QuickChatlinkTextMemory;
	
	local itemTable;
	local currentItem = self.QuickChatlinkCurrentItem;
	local checkSuffixes = (currentItem ~= nil);
	
	if (textMemory == "" or textMemory:len() >= text:len()) then
		-- User had entered "item of thing" but set the text to "item", so we must look through the excluded items to re-add the previously omitted suggestions.
		itemTable, checkSuffixes = self:QuickChatlink_ExpandSuggestionMemory(text, self.QuickChatlinkIncludedItems, self.QuickChatlinkExcludedItems);
		
	elseif (not currentItem) then
		-- User had entered "item" and added text to create "item of thing", so we must narrow the potential suggestions further.
		itemTable, checkSuffixes = self:QuickChatlink_NarrowSuggestionMemory(text, self.QuickChatlinkIncludedItems, self.QuickChatlinkExcludedItems);
	end
	
	self.QuickChatlinkTextMemory = text;
	
	
	if (checkSuffixes) then
		if (itemTable) then
			self.QuickChatlinkCurrentItem = itemTable;
		end
	else
		self.QuickChatlinkCurrentItem = nil;
	end
	
	currentItem = self.QuickChatlinkCurrentItem;
	
	
	if (not itemTable and not checkSuffixes) then
		self.QUICKCHATLINK_SUGGESTIONS_BUTTON:Hide();
		UIDROPDOWNMENU_OPEN_MENU = nil;
		
		if (self.QuickChatlinkSuggestedItemTable) then
			ChatFrameEditBox:HighlightText(0, 0);
			self.QuickChatlinkSuggestedItemTable = nil;
			self.QuickChatlinkSuggestedSuffixID = nil;
		end
		
		return;
	end
	
	
	self.QUICKCHATLINK_SUGGESTIONS_BUTTON:Show();
	
	if (DropDownList1:IsShown() and UIDROPDOWNMENU_OPEN_MENU == "LootLink_QuickChatlink_SuggestionsDD") then
		local dropdown = self.QUICKCHATLINK_SUGGESTIONS_DD;
		dropdown:Hide();
		UIDROPDOWNMENU_OPEN_MENU = nil;
		ToggleDropDownMenu(1, nil, dropdown);
	end
	
	
	self:QuickChatlink_SetHighlightedAutoCompletion(text, (currentItem or itemTable), checkSuffixes);
end




function LootLink:QuickChatlink_SetHighlightedAutoCompletion(text, itemTable, checkSuffixes, editBox)
	if (not itemTable) then return; end
	
	if (not editBox) then editBox = ChatFrameEditBox; end
	
	
	self.QuickChatlinkSuggestedItemTable = itemTable;
	
	local itemName = itemTable[1];
	
	
	local suffixTable = itemTable[3];
	
	if (suffixTable and checkSuffixes) then
		local next = next;
		local stringsub = self.STRING_LIBRARY.sub;
		local stringlower = self.STRING_LIBRARY.lower;
		
		local suffixIDsToNameKeys = self.SUFFIX_IDS_TO_NAME_KEYS;
		local suffixNameKeysToNames = self.SUFFIX_NAME_KEYS_TO_NAMES;
		
		local loweredText = stringlower(text);
		local loweredName = stringlower(itemName);
		local textLength = text:len();
		
		local matchingSuffixName;
		
		local suffixID = next(suffixTable);
		local suffixName;
		
		
		while (suffixID and not matchingSuffixName) do
			suffixName = suffixNameKeysToNames[suffixIDsToNameKeys[suffixID]];
			
			if (stringsub(loweredName.." "..stringlower(suffixName), 1, textLength) == loweredText) then
				matchingSuffixName = suffixName;
				self.QuickChatlinkSuggestedSuffixID = suffixID;
			else
				suffixID = next(suffixTable, suffixID);
			end
		end
		
		
		if (matchingSuffixName) then
			itemName = (itemName.." "..matchingSuffixName);
		end
	end
	
	
	local nonHighlightedText = (editBox:GetText():match("^.*%[")..text);
	
	editBox:SetText(nonHighlightedText..itemName:sub(text:len() + 1).."]");
	editBox:HighlightText(nonHighlightedText:len(), nil);
end




ChatEdit_CustomTabPressed = function()
	LootLink.Original_ChatEdit_CustomTabPressed();
	
	
	if (LootLink.QuickChatlinkSuggestedItemTable) then
		
		if (IsShiftKeyDown()) then
			if (LootLink.QuickChatlinkCurrentItem) then
				LootLink.QuickChatlinkSuggestedSuffixID = next(LootLink.QuickChatlinkCurrentItem[3], LootLink.QuickChatlinkSuggestedSuffixID);
				
				if (not LootLink.QuickChatlinkSuggestedSuffixID) then LootLink.QuickChatlinkSuggestedSuffixID = next(LootLink.QuickChatlinkCurrentItem[3]); end
				
				local editBox = this;
				local nonHighlightedText = editBox:GetText():match("^.*%["..LootLink.QuickChatlinkTextMemory:lower());
				
				editBox:SetText(
				  nonHighlightedText
				  .." "
				  ..LootLink.SUFFIX_NAME_KEYS_TO_NAMES[LootLink.SUFFIX_IDS_TO_NAME_KEYS[LootLink.QuickChatlinkSuggestedSuffixID]]
				  .."]"
				);
				editBox:HighlightText(nonHighlightedText:len(), nil);
				
				
			else
				local nextName, nextTable = next(LootLink.QuickChatlinkIncludedItems, LootLink.QuickChatlinkSuggestedItemTable[1]);
				
				if (not nextTable) then nextName, nextTable = next(LootLink.QuickChatlinkIncludedItems); end
				
				if (nextTable) then
					LootLink.QuickChatlinkCurrentItem = nil;
					LootLink.QuickChatlinkSuggestedSuffixID = nil;
					
					LootLink:QuickChatlink_SetHighlightedAutoCompletion(LootLink.QuickChatlinkTextMemory, nextTable, nil, this);
				end
			end
			
		else
			LootLink:QuickChatlink_InsertSuggestedItem(LootLink.QuickChatlinkSuggestedItemTable, LootLink.QuickChatlinkSuggestedSuffixID);
		end
		
		return true; -- Do NOT continue with the normal tab behaviour.
		
		
	else
		return false; -- Continue with the normal tab behaviour.
	end
end




function LootLink:QuickChatlink_RebuildSuggestionMemory(included, excluded)
	local pairs = pairs;
	
	
	for key in pairs(included) do
		included[key] = nil;
	end
	
	for key in pairs(excluded) do
		excluded[key] = nil;
	end
	
	
	for baseID, itemTable in pairs(self.Database) do
		excluded[itemTable[1]] = itemTable;
	end
end




function LootLink:QuickChatlink_ExpandSuggestionMemory(text, included, excluded)
	local stringlower = self.STRING_LIBRARY.lower;
	local stringsub = self.STRING_LIBRARY.sub;
	
	local textLength = text:len();
	text = stringlower(text);
	local loweredText;
	local exactMatch;
	
	
	-- Add anything which DOES match.
	for itemName, itemTable in pairs(excluded) do
		loweredText = stringlower(itemName);
		
		if (stringsub(loweredText, 1, textLength) == text) then
			included[itemName] = itemTable;
			excluded[itemName] = nil;
			
			if (loweredText == text) then
				exactMatch = itemTable;
			end
		end
	end
	
	
	if (exactMatch) then
		return exactMatch, true;
	else
		local name, itemTable = next(included);
		return itemTable, nil;
	end
end




function LootLink:QuickChatlink_NarrowSuggestionMemory(text, included, excluded)
	local stringlower = self.STRING_LIBRARY.lower;
	local stringsub = self.STRING_LIBRARY.sub;
	
	local textLength = text:len();
	text = stringlower(text);
	local loweredText;
	local exactMatch;
	
	
	-- Remove anything which does NOT match.
	for itemName, itemTable in pairs(included) do
		loweredText = stringlower(itemName);
		
		if (stringsub(loweredText, 1, textLength) ~= text) then
			included[itemName] = nil;
			excluded[itemName] = itemTable;
			
		elseif (loweredText == text) then
			exactMatch = itemTable;
		end
	end
	
	
	if (exactMatch) then
		return exactMatch, true;
	else
		local name, itemTable = next(included);
		return itemTable, nil;
	end
end




function LootLink:QuickChatlink_SuggestionsDDButton_OnClick(suffix)
	self:QuickChatlink_InsertSuggestedItem(this.value, suffix);
end



function LootLink:QuickChatlink_SuggestionsDD_Initialize(level)
	if (level == 2) then
		local itemTable = this:GetParent().value;
		
		local addButton = UIDropDownMenu_AddButton;
		
		local buttonInfo = self:Main_GetReusableTable(1);
		buttonInfo.notCheckable = true;
		buttonInfo.func = self.QuickChatlink_SuggestionsDDButton_OnClick;
		buttonInfo.arg1 = self;
		buttonInfo.value = itemTable;
		
		buttonInfo.text = self.LOCALIZATION.QUICKCHATLINK_NO_SUFFIX;
		addButton(buttonInfo, 2);
		
		
		for suffixName in pairs(itemTable[3]) do
			buttonInfo.text = suffixName;
			buttonInfo.arg2 = suffixName;
			addButton(buttonInfo, 2);
		end
		
		
		
	else
		local addButton = UIDropDownMenu_AddButton;
		
		local buttonInfo = self:Main_GetReusableTable(1);
		buttonInfo.notCheckable = true;
		
		buttonInfo.text = self.LOCALIZATION.QUICKCHATLINK_SUGGESTIONS:format(self.QuickChatlinkTextMemory);
		buttonInfo.isTitle = true;
		addButton(buttonInfo);
		
		buttonInfo.isTitle = nil;
		buttonInfo.disabled = nil;
		buttonInfo.func = self.QuickChatlink_SuggestionsDDButton_OnClick;
		buttonInfo.arg1 = self;
		
		
		local itemMemory = self.QuickChatlinkIncludedItems;
		
		local index = 1;
		local itemName, itemTable = next(itemMemory);
		
		
		while (index <= 10 and itemName) do
			buttonInfo.value = itemTable;
			buttonInfo.text = itemName;
			
			if (itemTable[3]) then
				buttonInfo.hasArrow = true;
				buttonInfo.notClickable = true;
			else
				buttonInfo.hasArrow = nil;
				buttonInfo.notClickable = nil;
				buttonInfo.disabled = nil;
			end
			
			addButton(buttonInfo);
			
			index = (index + 1);
			itemName, itemTable = next(itemMemory, itemName);
		end
	end
end


LootLink.QUICKCHATLINK_SUGGESTIONS_DD.initialize = (function(level) LootLink:QuickChatlink_SuggestionsDD_Initialize(level); end);




function LootLink:QuickChatlink_ChatEdit_OnChar(editBox, char)
	if (not self.Config.EnableQuickChatlink) then return; end
	
	
	if (char == "]") then
		-- Parse the text when the "]" key is pressed, but safeguard against spamming of the "]" key and blank links.
		if (editBox.LootLink_PreviousChar ~= "]" and editBox.LootLink_PreviousChar ~= "[") then
			local oldText = editBox:GetText();
			
			if (not self.Config.NoQuickChatlinkForSlashCommands or oldText:sub(1, 1) ~= "/") then
				local newText = oldText:gsub("(|?h?)%[(.-)%](|?h?)", LootLink_QuickChatlink_GetLinkForText);
				
				if (oldText ~= newText) then
					editBox:SetText(newText);
				end
			end
		end
		
		editBox.LootLink_ShowSuggestions = nil;
		self.QUICKCHATLINK_SUGGESTIONS_BUTTON:Hide();
		
		
	elseif (char == "[") then
		if (not self.Config.NoSuggestionsForQuickChatlink) then
			editBox.LootLink_ShowSuggestions = true;
			self:QuickChatlink_RebuildSuggestionMemory(self.QuickChatlinkIncludedItems, self.QuickChatlinkExcludedItems);
		else
			editBox.LootLink_ShowSuggestions = nil;
		end
		
		
	elseif (editBox.LootLink_ShowSuggestions) then
		local text = editBox:GetText();
		
		if ((not self.Config.NoQuickChatlinkForSlashCommands or text:sub(1, 1) ~= "/") and text:sub(-2, -1) ~= "|h") then
			
			local textToMatch = text:match("^.*%[(.+)$");
			if (textToMatch and textToMatch ~= "") then
				self:QuickChatlink_BuildSuggestions(textToMatch);
			end
			
		end
	end
	
	
	editBox.LootLink_PreviousChar = char;
end



ChatFrameEditBox:SetScript("OnChar",
  function(self, char)
	local func = LootLink.Original_ChatFrameEditBox_OnChar;
	if (func) then func(self, char); end
	
	LootLink:QuickChatlink_ChatEdit_OnChar(self, char);
  end
);




end

