

function LootLink:QuickSearch_Initialize()


self:QuickSearch_InitializeXML();

self.QuickSearch_InitializeXML = nil;


self:QuickSearch_InitializeLocalization();

self.QuickSearch_InitializeLocalization = nil;




local LootLink = self;




LootLink.CurrentQuickSearchIndex = 1;




function LootLink:QuickSearch_SearchByName(name)
	local params = self.SearchParameters;
	
	for key in pairs(params) do
		params[key] = nil;
	end
	
	
	self.QUICKSEARCH_SEARCH_FRAME:SetBackdropBorderColor(0.5, 0.5, 0.5);
	
	
	if (name ~= "") then
		params.name = name;
	end
	
	if (self.SEARCH_FRAME:IsShown()) then
		self:Search_LoadValues();
	end
	
	
	PlaySound("gsTitleOptionOk");
	
	self:Results_FullRebuild();
end




function LootLink:QuickSearch_GetNextMatchIndex(currentIndex, text)
	local resultsList = self.ResultsList;
	
	if (#resultsList == 0) then return nil; end
	
	
	local stringfind = self.STRING_LIBRARY.find;
	local stringlower = self.STRING_LIBRARY.lower;
	
	local plain = (not IsAltKeyDown());
	text = stringlower(text);


	for index = (currentIndex + 1), #resultsList do
		if (stringfind(stringlower(resultsList[index][1] or resultsList[index]), text, 1, plain)) then
			return index;
		end
	end
	
	
	for index = 1, currentIndex do
		if (stringfind(stringlower(resultsList[index][1] or resultsList[index]), text, 1, plain)) then
			return index;
		end
	end
	
	
	return nil;
end




function LootLink:QuickSearch_ScrollToNextMatch(text)
	if (text == "") then return; end
	
	
	local nextMatch = self:QuickSearch_GetNextMatchIndex(self.CurrentQuickSearchIndex, text);
	
	if (nextMatch) then
		self.CurrentQuickSearchIndex = nextMatch;
		
		self.QUICKSEARCH_SEARCH_FRAME:SetBackdropBorderColor(0.5, 0.5, 0.5);
		
		local offset = (nextMatch - 1);
		if ((offset + self.NUM_RESULT_BUTTONS) > #self.ResultsList) then
			offset = (#self.ResultsList - self.NUM_RESULT_BUTTONS);
		end
		if (offset < 0) then offset = 0; end
		
		LootLink_ResultsFrame_ListScrollFrame.offset = offset;
		LootLink_ResultsFrame_ListScrollFrameScrollBar:SetValue(self.MATH_LIBRARY.ceil(offset * self.RESULT_BUTTON_HEIGHT));
		
	else
		self.QUICKSEARCH_SEARCH_FRAME:SetBackdropBorderColor(0.8, 0.0, 0.4);
	end
	
	
	self:Results_UpdateCurrentPage();
end




function LootLink:QuickSearch_OnTextChanged(text, checkFirst)
	if (checkFirst) then
		if (text:lower() == (GetBindingKey("TOGGLELOOTLINK") or ""):lower()) then
			self.QUICKSEARCH_SEARCH_EB:SetText("");
			text = ("");
		end
	end
	
	
	if (text == "") then
		self.QUICKSEARCH_HELP_TEXT:SetTextColor(0.7, 0.7, 0.7);
	else
		self.QUICKSEARCH_HELP_TEXT:SetTextColor(0.3, 0.3, 0.3);
	end
	
	
	self.CurrentQuickSearchIndex = 1;
end




end

