

function LootLink:QuickSearch_InitializeXML()




local createFrame = CreateFrame;




local quickSearchFrame = createFrame("Frame", "LootLink_QuickSearch_SearchFrame", self.RESULTS_FRAME);

quickSearchFrame.LOOTLINK = self;
self.QUICKSEARCH_SEARCH_FRAME = quickSearchFrame;

quickSearchFrame:Hide();
quickSearchFrame:SetWidth(310);
quickSearchFrame:SetHeight(28);
quickSearchFrame:SetPoint("BOTTOMLEFT", self.RESULTS_FRAME, "BOTTOMLEFT", 12, 77);



local backdropTable = self:Main_GetReusableTable(1);
backdropTable.bgFile = ("Interface\\Tooltips\\UI-Tooltip-Background");
backdropTable.edgeFile = ("Interface\\Tooltips\\UI-Tooltip-Border");
backdropTable.tile = true;
backdropTable.tileSize = 16;
backdropTable.edgeSize = 16;

local insetsTable = self:Main_GetReusableTable(2);
insetsTable.left = 5;
insetsTable.right = 5;
insetsTable.top = 5;
insetsTable.bottom = 5;
backdropTable.insets = insetsTable;

quickSearchFrame:SetBackdrop(backdropTable);
quickSearchFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
quickSearchFrame:SetBackdropBorderColor(0.5, 0.5, 0.5, 1.0);



local helpText = quickSearchFrame:CreateFontString("LootLink_QuickSearch_HelpText", "BACKGROUND", "ChatFontNormal");

self.QUICKSEARCH_HELP_TEXT = helpText;

helpText:SetTextColor(0.7, 0.7, 0.7, 1.0);

helpText:SetPoint("CENTER", quickSearchFrame, "CENTER", 0, 0);



local editBox = createFrame("EditBox", "LootLink_QuickSearch_SearchEB", quickSearchFrame);

editBox.LOOTLINK = self;
self.QUICKSEARCH_SEARCH_EB = editBox;

editBox:SetAutoFocus(false);
editBox:SetMaxLetters(64);

editBox:SetWidth(200);
editBox:SetHeight(20);
editBox:SetPoint("LEFT", quickSearchFrame, "LEFT", 8, -1);
editBox:SetPoint("RIGHT", quickSearchFrame, "RIGHT", -8, -1);

editBox:SetFontObject("ChatFontNormal");
editBox:SetTextColor(1.0, 1.0, 1.0, 1.0);
editBox:SetShadowOffset(1, -1);
editBox:SetShadowColor(0.0, 0.0, 0.0);



local clearButton = createFrame("Button", "LootLink_QuickSearch_ClearButton", quickSearchFrame, "UIPanelCloseButton");

clearButton.LOOTLINK = self;

clearButton:SetWidth(40);
clearButton:SetHeight(40);
clearButton:SetPoint("LEFT", editBox, "RIGHT", -2, 1);



editBox:SetScript("OnShow",
  function(self)
	if (self.LOOTLINK.Config.AutoFocusQuickSearch) then
		self.CheckFirstLetter = true;
	end
  end
);



editBox:SetScript("OnEnterPressed",
  function(self)
	if (IsAltKeyDown()) then
		self:SetText("");
	else
		self.LOOTLINK:QuickSearch_SearchByName(self:GetText());
	end
  end
);


editBox:SetScript("OnTabPressed", (function(self) self.LOOTLINK:QuickSearch_ScrollToNextMatch(self:GetText()); end));


editBox:SetScript("OnEscapePressed", (function(self) self:ClearFocus(); end));



editBox:SetScript("OnTextChanged",
  function(self)
	self.LOOTLINK:QuickSearch_OnTextChanged(self:GetText(), self.CheckFirstLetter);
	self.CheckFirstLetter = nil;
  end
);



editBox:SetScript("OnEditFocusLost", (function(self) self:HighlightText(0, 0); end));


editBox:SetScript("OnEditFocusGained", (function(self) self:HighlightText(); end));



clearButton:SetScript("OnClick",
  function(self)
	self.LOOTLINK.QUICKSEARCH_SEARCH_EB:SetText("");
	self.LOOTLINK:QuickSearch_SearchByName();
  end
);


--clearButton:Hide()
--editBox:SetWidth(240);


end

